
/*** Includes ***/
#include "demo_2btn.h"
#include "main.h"
#include "draw.h"
#include "spi_dma.h"
#include "AZQ_util.h"
#include "iqs269.h"
#include "IQS269A_settings_2btn.h"

demo_2btn_s demo;
hall_2btn_s hall;
buttons_2btn_s buttons;
pm_2btn_s pm;

iqs269_s *_iqs269Ptr2;

Mode_2btn_t mode;

uint8_t count;

bool ref_flag = false;
bool wearATI = false;

Ref_heat_e Ref_Heat_State = ref_state;

Delta_e delta;
mode_e mode_Wear_DynC;

char ch4delta1[5] = {0, 0, 0, 0, 0};
int16_t new_ch14delta = 0;
int16_t new_ch4delta = 0;
uint8_t ch0prox = 0;
int16_t new_ch5delta = 0;

/**
 * @brief Configure settings for IQS269 2 Button demo
 *
 * @param None
 *
 * @retval None
 */
void Configure_demo_2btn(void){
	/* Configure IO_pin, used for Heat. */
	gpio_init(HEAT_PORT, HEAT_PIN, LL_GPIO_MODE_OUTPUT, FUNCTION_NOT_USED, FUNCTION_NOT_USED, LL_GPIO_PULL_UP, LL_GPIO_SPEED_FREQ_VERY_HIGH);
	LL_GPIO_ResetOutputPin(HEAT_PORT, HEAT_PIN);


	/* Configure DEBUG Pin */
	#ifdef DEBUG_IO
	gpio_init(DEBUG_PORT, DEBUG_PIN, LL_GPIO_MODE_OUTPUT, FUNCTION_NOT_USED, FUNCTION_NOT_USED, LL_GPIO_PULL_UP, LL_GPIO_SPEED_FREQ_VERY_HIGH);
	LL_GPIO_SetOutputPin(DEBUG_PORT, DEBUG_PIN);
	#endif

	/* Configure the coordinates and numbers of the touch pad buttons. */
	buttons.button[B1].button_number = 	1;
	buttons.button[B1].xCoord = 20;
	buttons.button[B1].yCoord = 14;

	buttons.button[B2].button_number = 2;
	buttons.button[B2].xCoord = 40;
	buttons.button[B2].yCoord = 14;


	/* Initialize zero states */
	mode.current.wear = true;
	mode.current.dyC = false;

	mode.previous.wear = false;
	mode.previous.dyC = false;

	mode_Wear_DynC = wear;
}

/**
 * @brief Initialize the IQS69A settings for the 2 Button demo
 *
 * @param None
 *
 * @retval None
 */
void init_settings_2btn(void)
{

	// Addresses 0x80 Byte0 to 0x85 Byte1.

			_iqs269Ptr2->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_pmu_general_settings 		= PMU_GENERAL_SETTINGS;
			_iqs269Ptr2->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_i2c_general_settings 		= I2C_GENERAL_SETTINGS;
			_iqs269Ptr2->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_sys_chb_active 			= SYS_CHB_ACTIVE;
			_iqs269Ptr2->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_acf_lta_filter_settings	 = ACF_LTA_FILTER_SETTINGS;
			_iqs269Ptr2->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_lta_chb_reseed_enabled 	= LTA_CHB_RESEED_ENABLED;
			_iqs269Ptr2->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_uis_global_events_mask 	= UIS_GLOBAL_EVENTS_MASK;
			_iqs269Ptr2->IQSMemoryMap.iqs269_rep_timing.iqs269_pmu_report_rate_np 				= PMU_REPORT_RATE_NP;
			_iqs269Ptr2->IQSMemoryMap.iqs269_rep_timing.iqs269_pmu_report_rate_lp 				= PMU_REPORT_RATE_LP;
			_iqs269Ptr2->IQSMemoryMap.iqs269_rep_timing.iqs269_pmu_report_rate_ulp				= PMU_REPORT_RATE_ULP;
			_iqs269Ptr2->IQSMemoryMap.iqs269_rep_timing.iqs269_pmu_mode_timout					= PMU_MODE_TIMOUT;
			_iqs269Ptr2->IQSMemoryMap.iqs269_rep_timing.iqs269_i2c_window_timeout 				= I2C_WINDOW_TIMEOUT;
			_iqs269Ptr2->IQSMemoryMap.iqs269_rep_timing.iqs269_lta_halt_timeout 				= LTA_HALT_TIMEOUT;
			_iqs269Ptr2->IQSMemoryMap.iqs269_global_settings.iqs269_general_settings0			= PXS_GENERAL_SETTINGS0;
			_iqs269Ptr2->IQSMemoryMap.iqs269_global_settings.iqs269_general_settings1			= PXS_GENERAL_SETTINGS1;
			_iqs269Ptr2->IQSMemoryMap.iqs269_global_settings.iqs269_abs_cap_settings			= UIS_ABSOLUTE_CAPACITANCE;
			_iqs269Ptr2->IQSMemoryMap.iqs269_global_settings.iqs269_ref_chan_gensetting			= UIS_DCF_GENERAL_SETTINGS;
			_iqs269Ptr2->IQSMemoryMap.iqs269_global_settings.iqs269_ev_block					= GEM_CHB_BLOCK_NFOLLOW;
			_iqs269Ptr2->IQSMemoryMap.iqs269_global_settings.iqs269_gen_res7					= MOV_CHB_MOVEMENT_CHANNEL;
			_iqs269Ptr2->IQSMemoryMap.iqs269_global_settings.iqs269_chan_sel_slid0				= UIS_CHB_SLIDER0;
			_iqs269Ptr2->IQSMemoryMap.iqs269_global_settings.iqs269_chan_sel_slid1				= UIS_CHB_SLIDER1;
			_iqs269Ptr2->IQSMemoryMap.iqs269_global_settings.iqs269_tap_timout_slid				= UIS_GESTURE_TAP_TIMEOUT;
			_iqs269Ptr2->IQSMemoryMap.iqs269_global_settings.iqs269_swipe_timout_slid			= UIS_GESTURE_SWIPE_TIMEOUT;
			_iqs269Ptr2->IQSMemoryMap.iqs269_global_settings.iqs269_swipe_thres_slid			= UIS_GESTURE_THRESHOLD;
			_iqs269Ptr2->IQSMemoryMap.iqs269_global_settings.iqs269_chb_reseed_en				= LTA_CHB_RESEED;

			/* Channel 0 Settings - Read/Write */
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_crxsel_ch0 				=  PXS_CRXSEL_CH0;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_ctxsel_ch0 				=  PXS_CTXSEL_CH0;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_proxctrl_ch0 				=  PXS_PROXCTRL_CH0;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_proxcfg0_ch0 				=  PXS_PROXCFG0_CH0 ;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_proxcfg1_testreg0_ch0		=  PXS_PROXCFG1_TESTREG0_CH0;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch0_settings.iqs269_ati_base_and_target_ch0		=  ATI_BASE_AND_TARGET_CH0;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch0_settings.iqs269_ati_mirror_ch0 				=  ATI_MIRROR_CH0;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch0_settings.iqs269_ati_pcc_ch0 					=  ATI_PCC_CH0;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_prox_threshold_ch0 		=  PXS_PROX_THRESHOLD_CH0;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_touch_threshold_ch0 		=  PXS_TOUCH_THRESHOLD_CH0;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_deep_threshold_ch0 		=  PXS_DEEP_THRESHOLD_CH0;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_hysteresis_ch0 			=  PXS_HYSTERESIS_CH0;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch0_settings.iqs269_dcf_chb_association_ch0 		=  DCF_CHB_ASSOCIATION_CH0;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch0_settings.iqs269_dcf_weight_ch0 				=  DCF_WEIGHT_CH0;

			/* Channel 1 Settings - Read/Write */
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_crxsel_ch1 				=  PXS_CRXSEL_CH1;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_ctxsel_ch1 				=  PXS_CTXSEL_CH1;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_proxctrl_ch1 				=  PXS_PROXCTRL_CH1;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_proxcfg0_ch1 				=  PXS_PROXCFG0_CH1;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_proxcfg1_testreg0_ch1		=  PXS_PROXCFG1_TESTREG0_CH1;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch1_settings.iqs269_ati_base_and_target_ch1		=  ATI_BASE_AND_TARGET_CH1;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch1_settings.iqs269_ati_mirror_ch1 				=  ATI_MIRROR_CH1;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch1_settings.iqs269_ati_pcc_ch1 					=  ATI_PCC_CH1;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_prox_threshold_ch1 		=  PXS_PROX_THRESHOLD_CH1;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_touch_threshold_ch1 		=  PXS_TOUCH_THRESHOLD_CH1;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_deep_threshold_ch1 		=  PXS_DEEP_THRESHOLD_CH1;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_hysteresis_ch1 			=  PXS_HYSTERESIS_CH1;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch1_settings.iqs269_dcf_chb_association_ch1 		=  DCF_CHB_ASSOCIATION_CH1;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch1_settings.iqs269_dcf_weight_ch1 				=  DCF_WEIGHT_CH1;

			/* Channel 2 Settings - Read/Write */
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_crxsel_ch2 				=  PXS_CRXSEL_CH2;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_ctxsel_ch2 				=  PXS_CTXSEL_CH2;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_proxctrl_ch2 				=  PXS_PROXCTRL_CH2;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_proxcfg0_ch2 				=  PXS_PROXCFG0_CH2;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_proxcfg1_testreg0_ch2		=  PXS_PROXCFG1_TESTREG0_CH2;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch2_settings.iqs269_ati_base_and_target_ch2		=  ATI_BASE_AND_TARGET_CH2;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch2_settings.iqs269_ati_mirror_ch2 				=  ATI_MIRROR_CH2;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch2_settings.iqs269_ati_pcc_ch2 					=  ATI_PCC_CH2;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_prox_threshold_ch2 		=  PXS_PROX_THRESHOLD_CH2;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_touch_threshold_ch2 		=  PXS_TOUCH_THRESHOLD_CH2;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_deep_threshold_ch2			=  PXS_DEEP_THRESHOLD_CH2;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_hysteresis_ch2 			=  PXS_HYSTERESIS_CH2;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch2_settings.iqs269_dcf_chb_association_ch2 		=  DCF_CHB_ASSOCIATION_CH2;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch2_settings.iqs269_dcf_weight_ch2 				=  DCF_WEIGHT_CH2;

			/* Channel 3 Settings - Read/Write */
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_crxsel_ch3 				=  PXS_CRXSEL_CH3;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_ctxsel_ch3 				=  PXS_CTXSEL_CH3;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_proxctrl_ch3 				=  PXS_PROXCTRL_CH3;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_proxcfg0_ch3 				=  PXS_PROXCFG0_CH3;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_proxcfg1_testreg0_ch3		=  PXS_PROXCFG1_TESTREG0_CH3;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch3_settings.iqs269_ati_base_and_target_ch3		=  ATI_BASE_AND_TARGET_CH3;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch3_settings.iqs269_ati_mirror_ch3 				=  ATI_MIRROR_CH3;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch3_settings.iqs269_ati_pcc_ch3 					=  ATI_PCC_CH3;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_prox_threshold_ch3 		=  PXS_PROX_THRESHOLD_CH3;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_touch_threshold_ch3 		=  PXS_TOUCH_THRESHOLD_CH3;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_deep_threshold_ch3			=  PXS_DEEP_THRESHOLD_CH3;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_hysteresis_ch3 			=  PXS_HYSTERESIS_CH3;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch3_settings.iqs269_dcf_chb_association_ch3 		=  DCF_CHB_ASSOCIATION_CH3;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch3_settings.iqs269_dcf_weight_ch3 				=  DCF_WEIGHT_CH3;

			/* Channel 4 Settings - Read/Write */
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_crxsel_ch4 				=  PXS_CRXSEL_CH4;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_ctxsel_ch4 				=  PXS_CTXSEL_CH4;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_proxctrl_ch4 				=  PXS_PROXCTRL_CH4;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_proxcfg0_ch4 				=  PXS_PROXCFG0_CH4;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_proxcfg1_testreg0_ch4		=  PXS_PROXCFG1_TESTREG0_CH4;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch4_settings.iqs269_ati_base_and_target_ch4		=  ATI_BASE_AND_TARGET_CH4;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch4_settings.iqs269_ati_mirror_ch4 				=  ATI_MIRROR_CH4;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch4_settings.iqs269_ati_pcc_ch4 					=  ATI_PCC_CH4;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_prox_threshold_ch4 		=  PXS_PROX_THRESHOLD_CH4;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_touch_threshold_ch4 		=  PXS_TOUCH_THRESHOLD_CH4;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_deep_threshold_ch4			=  PXS_DEEP_THRESHOLD_CH4;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_hysteresis_ch4 			=  PXS_HYSTERESIS_CH4;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch4_settings.iqs269_dcf_chb_association_ch4 		=  DCF_CHB_ASSOCIATION_CH4;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch4_settings.iqs269_dcf_weight_ch4 				=  DCF_WEIGHT_CH4;

			/* Channel 5 Settings - Read/Write */
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_crxsel_ch5 				=  PXS_CRXSEL_CH5;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_ctxsel_ch5 				=  PXS_CTXSEL_CH5;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_proxctrl_ch5 				=  PXS_PROXCTRL_CH5;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_proxcfg0_ch5 				=  PXS_PROXCFG0_CH5;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_proxcfg1_testreg0_ch5		=  PXS_PROXCFG1_TESTREG0_CH5;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch5_settings.iqs269_ati_base_and_target_ch5		=  ATI_BASE_AND_TARGET_CH5;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch5_settings.iqs269_ati_mirror_ch5 				=  ATI_MIRROR_CH5;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch5_settings.iqs269_ati_pcc_ch5 					=  ATI_PCC_CH5;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_prox_threshold_ch5 		=  PXS_PROX_THRESHOLD_CH5;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_touch_threshold_ch5 		=  PXS_TOUCH_THRESHOLD_CH5;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_deep_threshold_ch5			=  PXS_DEEP_THRESHOLD_CH5;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_hysteresis_ch5 			=  PXS_HYSTERESIS_CH5;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch5_settings.iqs269_dcf_chb_association_ch5 		=  DCF_CHB_ASSOCIATION_CH5;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch5_settings.iqs269_dcf_weight_ch5 				=  DCF_WEIGHT_CH5;

			/* Channel 6 Settings - Read/Write */
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_crxsel_ch6 				=  PXS_CRXSEL_CH6;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_ctxsel_ch6 				=  PXS_CTXSEL_CH6;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_proxctrl_ch6 				=  PXS_PROXCTRL_CH6;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_proxcfg0_ch6 				=  PXS_PROXCFG0_CH6;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_proxcfg1_testreg0_ch6		=  PXS_PROXCFG1_TESTREG0_CH6;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch6_settings.iqs269_ati_base_and_target_ch6		=  ATI_BASE_AND_TARGET_CH6;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch6_settings.iqs269_ati_mirror_ch6 				=  ATI_MIRROR_CH6;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch6_settings.iqs269_ati_pcc_ch6 					=  ATI_PCC_CH6;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_prox_threshold_ch6 		=  PXS_PROX_THRESHOLD_CH6;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_touch_threshold_ch6 		=  PXS_TOUCH_THRESHOLD_CH6;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_deep_threshold_ch6			=  PXS_DEEP_THRESHOLD_CH6;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_hysteresis_ch6 			=  PXS_HYSTERESIS_CH6;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch6_settings.iqs269_dcf_chb_association_ch6 		=  DCF_CHB_ASSOCIATION_CH6;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch6_settings.iqs269_dcf_weight_ch6 				=  DCF_WEIGHT_CH6;

			/* Channel 7 Settings - Read/Write */
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_crxsel_ch7 				=  PXS_CRXSEL_CH7;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_ctxsel_ch7 				=  PXS_CTXSEL_CH7;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_proxctrl_ch7 				=  PXS_PROXCTRL_CH7;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_proxcfg0_ch7 				=  PXS_PROXCFG0_CH7;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_proxcfg1_testreg0_ch7		=  PXS_PROXCFG1_TESTREG0_CH7;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch7_settings.iqs269_ati_base_and_target_ch7		=  ATI_BASE_AND_TARGET_CH7;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch7_settings.iqs269_ati_mirror_ch7 				=  ATI_MIRROR_CH7;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch7_settings.iqs269_ati_pcc_ch7 					=  ATI_PCC_CH7;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_prox_threshold_ch7 		=  PXS_PROX_THRESHOLD_CH7;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_touch_threshold_ch7 		=  PXS_TOUCH_THRESHOLD_CH7;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_deep_threshold_ch7			=  PXS_DEEP_THRESHOLD_CH7;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_hysteresis_ch7 			=  PXS_HYSTERESIS_CH7;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch7_settings.iqs269_dcf_chb_association_ch7 		=  DCF_CHB_ASSOCIATION_CH7;
			_iqs269Ptr2->IQSMemoryMap.iqs269_ch7_settings.iqs269_dcf_weight_ch7 				=  DCF_WEIGHT_CH7;
}

/**
 * @brief Reset the states of the 2btn demo state machines
 *
 * @param None
 *
 * @retval None
 */
void reset_demo_2btn(void)
{
	demo.startup_2btn_state = startup_2btn_begin;
	demo.run_2btn_state = demo_2btn_run_startup;
	init_settings_2btn();
	_iqs269Ptr2->state = IQS269_STATE_NONE;
	_iqs269Ptr2->init_state = IQS269_INIT_INTERFACE;
}

/**
 * @brief Run the startup routine for the 8btn demo board
 *
 * @param None
 *
 * @return None
 */
void run_demoStartupRoutine_2btn(void){
	switch (demo.startup_2btn_state)
	{
	// Display the Azoteq splash logo
	case startup_2btn_begin:
		if (ssd1306_CheckScreenReady(0))
		{
			oledClear_2btn();
			ssd1306_LoadLogo();
			demo.startup_2btn_state = startup_2btn_NP;
		}
		break;

	// PM demonstrations
	case startup_2btn_NP:
		if (ssd1306_CheckScreenReady(1000))
		{
			oledClear_2btn();
			fillRoundRect(X_MIDDLE - 15, 1, 15, 10, 2, White);
			oledDisplayText_2btn("NP", X_MIDDLE - 13, 2, Font_6x8, Black);
			demo.startup_2btn_state = startup_2btn_LP;
		}
		break;

	case startup_2btn_LP:
		if (ssd1306_CheckScreenReady(500))
		{
			oledClearPM_2btn();
			fillRoundRect(X_MIDDLE - 15, 1, 15, 10, 2, White);
			oledDisplayText_2btn("LP", X_MIDDLE - 13, 2, Font_6x8, Black);
			demo.startup_2btn_state = startup_2btn_ULP;
		}
		break;

	case startup_2btn_ULP:
		if (ssd1306_CheckScreenReady(500))
		{
			oledClearPM_2btn();
			fillRoundRect(X_MIDDLE - 15, 1, 20, 10, 2, White);
			oledDisplayText_2btn("ULP", X_MIDDLE - 13, 2, Font_6x8, Black);
			demo.startup_2btn_state = startup_2btn_ref;
		}
		break;
	//Wear detect demonstrations
	case startup_2btn_ref:
		if (ssd1306_CheckScreenReady(500))
		{
			oledDisplayText_2btn("Mode: Default", 25, 53, Font_6x8, White);				//display default mode in the middle bottom
			oledClearPM_2btn();
			oledDisplayText_2btn("REF", 2, 2, Font_6x8, White);							//display ref upper left corner
			demo.startup_2btn_state = startup_2btn_heat;
		}
		break;

	case startup_2btn_heat:
		if (ssd1306_CheckScreenReady(500))
		{
			oledDisplayText_2btn("HEAT", 100, 2, Font_6x8, White);						//display heat upper right corner
			demo.startup_2btn_state = startup_2btn_defaultMode_num;
		}
		break;

	// This case displays the number of both "buttons" and simulates a proximity state in wear detection
	case startup_2btn_defaultMode_num:
		if (ssd1306_CheckScreenReady(500))
		{
			oledDisplayText_2btn("1", 35, 25, Font_11x18, White);
			oledDisplayText_2btn("2", 75, 25, Font_11x18, White);
			demo.startup_2btn_state = startup_2btn_defaultMode_block1;
		}
		break;

	// This case displays the number and one rectangle of both "buttons" and simulates a touch state in wear detection
	case startup_2btn_defaultMode_block1:
		if (ssd1306_CheckScreenReady(500))
		{
			drawRoundRect(25, 17, BUTTON_SIZE + 10, BUTTON_SIZE + 10, 5, White);
			drawRoundRect(65, 17, BUTTON_SIZE + 10, BUTTON_SIZE + 10, 5, White);
			demo.startup_2btn_state = startup_2btn_defaultMode_block2;
		}
		break;

	// This case displays the number and two rectangles of both "buttons" and simulates a deep touch state in wear detection
	case startup_2btn_defaultMode_block2:
		if (ssd1306_CheckScreenReady(500))
		{
			drawRoundRect(27, 19, BUTTON_SIZE + 6, BUTTON_SIZE + 6, 5, White);
			drawRoundRect(67, 19, BUTTON_SIZE + 6, BUTTON_SIZE + 6, 5, White);
			demo.startup_2btn_state = startup_2btn_WearDelta;
		}
		break;

	// Display wear
	case startup_2btn_WearDelta:
		if (ssd1306_CheckScreenReady(500))
		{
			oledDisplayText_2btn("Wear", 100, Y_MIDDLE - 10, Font_6x8, White);
			demo.startup_2btn_state = startup_2btn_dynamicC_start;
		}
		break;

	//Dynamic C startup loop (similar to hall effect)
	case startup_2btn_dynamicC_start:
		if (ssd1306_CheckScreenReady(500))
		{
			oledClearModeName_2btn();
			oledClearAllButtons_2btn();
			oledClearWear();
			oledDisplayText_2btn("Mode: Dynamic C", 25, 53, Font_6x8, White);
			/* To fix the tail of the y character being cut off. */
			SSD1306_DrawLine(68, 60, 70, 60, White);
			oledDisplayText_2btn("MC", 40, 15, Font_6x8, White);
			oledDisplayText_2btn("SC", 85, 15, Font_6x8, White);
			SSD1306_DrawLine(19, Y_MIDDLE, 39, Y_MIDDLE, White);
			SSD1306_DrawLine(64, Y_MIDDLE, 84, Y_MIDDLE, White);
			count = 0;	//counter for hall startup routine
			demo.startup_2btn_state = startup_2btn_dynamicC_plus;
		}
		break;

	case startup_2btn_dynamicC_plus:
		if (ssd1306_CheckScreenReady(40)) {
			if (count<20)
			{
				SSD1306_DrawFilledRectangle(25, Y_MIDDLE - (count), 8, (count), White);
				SSD1306_DrawFilledRectangle(70, Y_MIDDLE - (count), 8, (count), White);
				count++;
			} else{
				//clear bar area
				SSD1306_DrawFilledRectangle(25, 10, 8, 21, Black);
				SSD1306_DrawFilledRectangle(70, 10, 8, 21, Black);
				SSD1306_DrawLine(19, Y_MIDDLE, 39, Y_MIDDLE, White);
				SSD1306_DrawLine(64, Y_MIDDLE, 84, Y_MIDDLE, White);
				demo.startup_2btn_state = startup_2btn_dynamicC_minus;
				count = 0;
			}
		}
		break;

	case startup_2btn_dynamicC_minus:
		if (ssd1306_CheckScreenReady(40))
		{
			if (count<20) {
				SSD1306_DrawFilledRectangle(25, Y_MIDDLE, 8, count, White);
				SSD1306_DrawFilledRectangle(70, Y_MIDDLE, 8, count, White);
				count++;
			}
			else
			{
				demo.startup_2btn_state = startup_2btn_hall_plus;
			}
		}
		break;

	// Hall Demonstration
	case startup_2btn_hall_plus:
		if (ssd1306_CheckScreenReady(500)) {
			oledClearHeat();
			oledClearAllButtons_2btn();
			oledClearWear();
			oledDisplayText_2btn("Hall", 0, 2, Font_6x8, White);
			oledDisplayText_2btn("+", 0, Y_MIDDLE - 10, Font_6x8, White);
			//center line
			SSD1306_DrawLine(0, Y_MIDDLE, 20, Y_MIDDLE, White);
			count = 0;	//counter for hall startup_2btn routine
			demo.startup_2btn_state = startup_2btn_hall_plus_loop;
		}
		break;

	case startup_2btn_hall_plus_loop:
		if (ssd1306_CheckScreenReady(40)) {
			if (count<20) {
				SSD1306_DrawFilledRectangle(6, Y_MIDDLE - (count), 8, (count), White);
				count++;
			} else
			{
				//clear bar area
				SSD1306_DrawFilledRectangle(6, Y_MIDDLE - 21, 8, 21, Black);
				SSD1306_DrawFilledRectangle(0, Y_MIDDLE - 10, 6, 8, Black);
				oledDisplayText_2btn("-", 0, Y_MIDDLE + 5, Font_6x8, White);
				SSD1306_DrawLine(0, Y_MIDDLE, 20, Y_MIDDLE, White);
				demo.startup_2btn_state = startup_2btn_hall_minus_loop;
				count = 0;
			}
		}
		break;
	case startup_2btn_hall_minus_loop:
		if (ssd1306_CheckScreenReady(40)) {

			if (count<20) {
				SSD1306_DrawFilledRectangle(6, Y_MIDDLE, 8, count, White);
				count++;
			} else{
				demo.startup_2btn_state = startup_2btn_clearAll;
			}
		}
		break;

	case startup_2btn_clearAll:
		if (ssd1306_CheckScreenReady(500)) {
			//clear all
			oledClear_2btn();
			demo.startup_2btn_state = startup_2btn_end;
		}
		break;

	case startup_2btn_end:
		if (ssd1306_CheckScreenReady(0)) {
			fillRoundRect(X_MIDDLE - 15, 1, 15, 10, 2, White);
			oledDisplayText_2btn("NP", X_MIDDLE - 13, 2, Font_6x8, Black);
			oledDisplayText_2btn("200uA", X_MIDDLE + 2, 2, Font_6x8, White);
			oledDisplayText_2btn("Mode: Default", 25, 53, Font_6x8, White);
			SSD1306_DrawLine(0, Y_MIDDLE, 0 + 19, Y_MIDDLE, White);

			iqs269_deQueueValueUpdates();
			iqs269_enableHallUI(I2C_STOP);
			iqs269_QueueValueUpdates();

			demo.startup_2btn_state = startup_2btn_done;
			demo.run_2btn_state = demo_2btn_run_begin;
		}
		break;

	case startup_2btn_done:
		break;

	default:
		demo.startup_2btn_state = startup_2btn_begin;
		break;
	}

}


/**
 * @brief Run demo loop to update and display all segments of the demo
 *
 *  @param None
 *	@note Call this function in main run loop
 *
 * @retval None
 */
void run_demo_2btn(void)
{
	char dispBuff1[64];

	if ((_iqs269Ptr2->openwindow)||(!_iqs269Ptr2->jobdone))													//if ready window is open but I2C communications are active, return
		return;

	switch (demo.run_2btn_state)
	{
	case demo_2btn_run_startup:
			/* Run startup routine. */
			run_demoStartupRoutine_2btn();
			break;
	case demo_2btn_run_begin:
		if (_iqs269Ptr2->updated)
		{
			demo.run_2btn_state = demo_2btn_run_hall;
		}
		if (demo.update)
		{
			demo.update = false;
			ssd1306_CheckScreenReady(0);
		}

		break;
	// Run hall demonstration
	case demo_2btn_run_hall:
		run_2btn_hall();
		demo.run_2btn_state = demo_2btn_run_default_screen;
		break;

	//startup in normal screen, decide what mode is to be executed based on the state of mode.current (wear/dynC). The state is set in Mode button callback
	case demo_2btn_run_default_screen:
		// Run default mode demo if default mode is active
		if (mode.current.wear)
		{
			run_2btn_default();											//execute function for wear detect
			if(ref_flag == true)										//This flag is set in the button 1 callback, which evaluates the state of reference/heat
			{
				demo.run_2btn_state = demo_2btn_run_refdelta;						//If flag is set, skip to case that displays the delta for reference state
			}
			else
			{
				demo.run_2btn_state = demo_2btn_run_pm;
			}
		}
		// Run dynamic C mode if activated
		else if(mode.current.dyC)
		{
			// Skip default mode and execute dynamic C demo if mode is active
			run_2btn_dynC();											//execute function for dynamic C
			if(ref_flag == true)										//This flag is set in the button 1 callback, which evaluates the state of reference/heat
			{
				demo.run_2btn_state = demo_2btn_run_refdelta;						//If flag is set, skip to case that displays the delta for reference state
			}
			else
			{
				demo.run_2btn_state = demo_2btn_run_pm;
			}
		}
		break;

	//read channel 5 delta (reference channel for ch4) and display
	case demo_2btn_run_refdelta:

		new_ch5delta = iqs269_readChannelDelta(IQS269_CH5);				//read ch5 (reference channel) delta

		if(new_ch5delta != delta.prev_deltach5)							//if new delta not equal to previous delta, update screen with new delta
		{
			oledClearRefDelta();
			oledDisplayText_2btn((itoa(new_ch5delta, dispBuff1, 10)), 25, 2, Font_6x8, White);
		}
		delta.prev_deltach5 = new_ch5delta;
		demo.run_2btn_state = demo_2btn_run_pm;

		break;
	//run power mode demonstration
	case demo_2btn_run_pm:

		run_2btn_pm();
		demo.run_2btn_state = demo_2btn_run_done;

		break;

	case demo_2btn_run_done:

		_iqs269Ptr2->updated = false;
		demo.run_2btn_state = demo_2btn_run_begin;

		break;

	case demo_2btn_run_idle:
		// Do nothing
		break;

	default:
		break;
	}
}

/**
 * @brief Update the hall UI and update the screen if the delta and state changed
 *
 * @param None
 *
 * @return None
 */
void run_2btn_hall(void)
{
	uint8_t new_state;
	int16_t new_delta;

	if (iqs269_Channel_DeepTouchState(IQS269_CH7))
	{
		new_state = hall_2btn_deep;
		new_delta = (iqs269_readChannelDelta(IQS269_CH7));
	}
	else if (iqs269_Channel_TouchState(IQS269_CH7))
	{
		new_state = hall_2btn_touch;
		new_delta = (iqs269_readChannelDelta(IQS269_CH7));
	}
	else if (iqs269_Channel_ProxState(IQS269_CH7))
	{
		new_state = hall_2btn_prox;
		new_delta = (iqs269_readChannelDelta(IQS269_CH7));
	} else
	{
		new_state = hall_2btn_zero;
		new_delta = (iqs269_readChannelDelta(IQS269_CH7));
	}

	if ((hall.state == new_state) && ((hall.delta <= new_delta+0) && (hall.delta >= new_delta-0)))
	{
		return;
	}
	else
	{

		#ifdef DEBUG_HALL
		LL_GPIO_ResetOutputPin(DEBUG_PORT, DEBUG_PIN);
		#endif

		oledBar_Hall(0, new_delta, new_delta);

		#ifdef DEBUG_HALL
		LL_GPIO_SetOutputPin(DEBUG_PORT, DEBUG_PIN);
		#endif

		hall.state = new_state;
		hall.delta = new_delta;
		demo.update = true;
	}
}

/**
 * @brief Run wear detection mode
 *
 * @note This mode displays the channel state (channel 4) by displaying a number, a number and one rectangle or a number and 2 rectangles for prox, touch and deep touch respectively
 *
 * @param None
 *
 * @return None
 */
void run_2btn_default(void)
{
	char dispBuff1[64];
	new_ch4delta = iqs269_readChannelDelta(IQS269_CH4);				//read channel 4 (self cap channel) delta

	if ((new_ch4delta < -10) && (wearATI)) {
		wearATI = false;
		iqs269_deQueueValueUpdates();
		/* ATI all channels if board was inserted. */
		iqs269_atiChannels(0xFF, I2C_STOP);
		iqs269_QueueValueUpdates();
	} else
	{
		wearATI = true;
	}

	if(new_ch4delta != delta.prev_deltach4)							//if new delta not equal to previous delta, update screen with new delta
	{
		run_button_2btn(IQS269_CH4, B1, 25, 17, "1");				//run button 1
		run_button_2btn(IQS269_CH4, B2, 65, 17, "2");				//run button 2

		oledClearWear();
		oledClearWearDelta();

		if(iqs269_Channel_ProxState(IQS269_CH4))					//only display wear and delta if channel is in prox state
		{
		oledDisplayText_2btn("Wear", 100, Y_MIDDLE - 10, Font_6x8, White);
		oledDisplayText_2btn((itoa(new_ch4delta, dispBuff1, 10)), 100, Y_MIDDLE, Font_6x8, White);
		demo.update = true;
		}

	}

	delta.prev_deltach4 = new_ch4delta;
}

/**
 * @brief Run Dynamic C mode
 *
 * @note This mode displays bars similar to hall effect for ch4 (self capacitance) and ch1 (mutual capacitance). It also displays the touch state using a letter (P, T or D).
 *
 * @param None
 *
 * @retval None
 */
void run_2btn_dynC(void)
{
	int16_t new_ch1delta;
	int16_t new_ch4delta;

	/* Read channel one (mutual capacitance channel) delta. */
	new_ch1delta = (iqs269_readChannelDelta(IQS269_CH1));
	/* Read channel 4 (self capacitance channel) delta. */
	new_ch4delta = (iqs269_readChannelDelta(IQS269_CH4));


		/* Mutual capacitance bar. */
		if(iqs269_Channel_ProxState(IQS269_CH1))
		{
			/* If new delta not equal to previous delta, update screen with new delta and display bars. */
			if(new_ch1delta != delta.prev_deltach1)
			{
				oledDisplayText_2btn("MC", 50, 15, Font_6x8, White);
				touch_state_dynC(IQS269_CH1, 50);
				oledBar2btn(30, new_ch1delta, delta.prev_deltach1);
				demo.update = true;
			}
		}
		else
		{
			/* Clear screen. */
			oledClearDynCbasics(50);
			oledClearDynCState(50);
			oledClearDynCBar(30, Y_MIDDLE);
		}

	/* Self capacitance bar. */
	if(iqs269_Channel_ProxState(IQS269_CH4))
	{
		/* If new delta not equal to previous delta, update screen with new delta and display bars. */
		if(new_ch4delta != delta.prev_deltach4)
		{
		oledDisplayText_2btn("SC", 100, 15, Font_6x8, White);
		SSD1306_DrawLine(80, Y_MIDDLE, 100, Y_MIDDLE, White);
		touch_state_dynC(IQS269_CH4,  100);
		oledBar2btn(80, new_ch4delta, delta.prev_deltach4);
		}
	}
	else
	{
		/* Clear screen. */
		oledClearDynCbasics(100);
		oledClearDynCState(100);
		oledClearDynCBar(80, Y_MIDDLE - 21);
	}

	delta.prev_deltach1 = new_ch1delta;
	delta.prev_deltach4 = new_ch4delta;
}

/**
 * @brief Update the power modes UI and update the screen if the state changed.
 *
 * @param None
 *
 * @return None
 */
void run_2btn_pm(void)
{
	uint8_t new_state;
	switch (iqs269_GetPowerMode())
	{
	case IQS269_POWER_MODE_NORMAL:
		new_state = pm_2btn_np;
		break;
	case IQS269_POWER_MODE_LOW:
		new_state = pm_2btn_lp;
		break;
	case IQS269_POWER_MODE_ULTRA_LOW:
		new_state = pm_2btn_ulp;
		break;
	default:
		break;
	}

	if (pm.state != new_state)
	{
		pm.state = new_state;
		demo.update = true;
		switch (new_state)
		{
		case pm_2btn_np:
			oledClearPM_2btn();
			fillRoundRect(X_MIDDLE - 15, 1, 15, 10, 2, White);
			oledDisplayText_2btn("NP", X_MIDDLE - 13, 2, Font_6x8, Black);
			oledDisplayText_2btn("200uA", X_MIDDLE + 2, 2, Font_6x8, White);									//changed
			break;
		case pm_2btn_lp:
			oledClearPM_2btn();
			fillRoundRect(X_MIDDLE - 15, 1, 15, 10, 2, White);
			oledDisplayText_2btn("LP", X_MIDDLE - 13, 2, Font_6x8, Black);
			oledDisplayText_2btn("22uA", X_MIDDLE + 7, 2, Font_6x8, White);									//changed
			break;
		case pm_2btn_ulp:
			oledClearPM_2btn();
			fillRoundRect(X_MIDDLE - 15, 1, 20, 10, 2, White);
			oledDisplayText_2btn("ULP", X_MIDDLE - 13, 2, Font_6x8, Black);
			oledDisplayText_2btn("9uA", X_MIDDLE + 7, 2, Font_6x8, White);
			break;
		default:
			break;
		}
	}
}

/**
 * @brief Update the button state and display the state if it changed
 *
 * @param uint8_t : \b ch_x -  Specifies the IQS channel
 * @param uint8_t : \b button_tag -  Specifies the button number macro defined in demo.h
 * @param char* : \b numberText -  Specifies the text to be displayed in the button block
 *
 * @example run_button(IQS269_CH1, IQS269_CH3, B1, "1");
 *
 * @return None
 */
void run_button_2btn(uint8_t ch_x, uint8_t button_tag, uint8_t x_coord, uint8_t y_coord, char* numberText)
{
	if (iqs269_Channel_DeepTouchState(ch_x))
	{
		buttons.button[button_tag].new_state = b_2btn_deep;
	}
	else if (iqs269_Channel_TouchState(ch_x))
	{
		buttons.button[button_tag].new_state = b_2btn_touch;

	}
	else if (iqs269_Channel_ProxState(ch_x))
	{
		buttons.button[button_tag].new_state = b_2btn_prox;

	}
	else //None
	{
		buttons.button[button_tag].new_state = b_2btn_none;
	}

	if (buttons.button[button_tag].state != buttons.button[button_tag].new_state)
	{
			oledClearButton_2btn(x_coord, y_coord, BUTTON_SIZE2, Black);
			oledDrawButton2(numberText, x_coord, y_coord, Font_11x18, White, buttons.button[button_tag].new_state);
			demo.update = true;
			buttons.button[button_tag].state = buttons.button[button_tag].new_state;
	}
}



/**
 * @brief Update the button state and display the state if it changed for 2 button demo (only two buttons displayed on screen)
 *
 * @param char* : \b numberText -  Specifies the text to be displayed in the button block.
 * @param uint8_t : \b xCoord -  Specifies the x coordinate of the larger round rectangle.
 * @param uint8_t : \b yCoord -  Specifies the y coordinate of the larger round rectangle.
 * @param FontDef : \b font -  Specifies the font size to write the number text with.
 * @param SSD1306_COLOR : \b color -  Specifies the color of the number text and rectangles.
 * @param Button_e : \b state - Specifies the current state of the specific button.
 *
 * @example oledDrawButton(numberText, buttons.button[button_tag].xCoord, buttons.button[button_tag].yCoord, Font_6x8, White, buttons.button[button_tag].new_state);
 *
 * @return None
 */
void oledDrawButton2(char* numberText, uint8_t xCoord, uint8_t yCoord, FontDef Font, SSD1306_COLOR color, Button_2btn_e state)
{
	new_ch4delta = iqs269_readChannelDelta(IQS269_CH4);

	switch (state)
	{
	case b_2btn_deep:

		oledDisplayText_2btn(numberText, xCoord+10, yCoord+7, Font, color);
		drawRoundRect(xCoord, yCoord, BUTTON_SIZE2, BUTTON_SIZE2, 5, color);
		drawRoundRect(xCoord+2, yCoord+2, BUTTON_SIZE2 - 4, BUTTON_SIZE2 - 4, 3, color);

		break;
	case b_2btn_touch:

		oledDisplayText_2btn(numberText, xCoord+10, yCoord+7, Font, color);
		drawRoundRect(xCoord, yCoord, BUTTON_SIZE2, BUTTON_SIZE2, 5, color);

		break;
	case b_2btn_prox:

		oledDisplayText_2btn(numberText, xCoord+10, yCoord+7, Font, color);

		break;
	case b_2btn_none:
		break;
	default:
		break;
	}
}

/**
 * @brief Clear the button area of the specified button.
 *
 * @param uint8_t : \b xCoord -  Specifies the x coordinate of the larger round rectangle.
 * @param uint8_t : \b yCoord -  Specifies the y coordinate of the larger round rectangle.
 * @param uint8_t : \b size -  Specifies the size of the button on the display.
 * @param SSD1306_COLOR : \b color -  Specifies the color to clear with.
 *
 * @example oledClearButton(buttons.button[button_tag].xCoord, buttons.button[button_tag].yCoord, BUTTON_SIZE, Black);
 *
 * @return None
 */
void oledClearButton_2btn(uint8_t xCoord, uint8_t yCoord, uint8_t size, SSD1306_COLOR color)
{
	//SSD1306_DrawFilledRectangle(xCoord, yCoord, size-1, size-1, color);
	ssd1306_Clear_region(xCoord, yCoord, size + xCoord, size + yCoord, Black);
}

/**
 * @brief Set the cursor and write text.
 *
 *@param char* : \b text - Specifies the text to be written.
 * @param uint8_t : \b xCoord -  Specifies the x coordinate of the cursor.
 * @param uint8_t : \b yCoord -  Specifies the y coordinate of the cursor.
 * @param FontDef : \b Font -  Specifies the size of the text.
 * @param SSD1306_COLOR : \b color -  Specifies the color of the text.
 *
 * @example oledDisplayText_2btn("Hello World!", 15, 20, Font_6x8, White);
 * @example oledDisplayText_2btn(itoa(counts, dispBuff1, 10), 0, 54, Font_6x8, White);
 *
 * @return None
 */
void oledDisplayText_2btn(char* text, uint8_t xCoord, uint8_t yCoord, FontDef Font, SSD1306_COLOR color)
{
	ssd1306_SetCursor(xCoord, yCoord);
	ssd1306_WriteString(text, Font, color);
}

/**
 * @brief Clear the entire screen to Black.
 *
 * @param None
 *
 * @return None
 */
void oledClear_2btn(void)
{
	ssd1306_Fill(Black); // Clear all
}

/**
 * @brief Clear screen for mode switching (everything below PM and to the right of hall).
 *
 * @param none
 *
 * @return None
 */
void oledClearModeSwitch(void)
{
//	SSD1306_DrawFilledRectangle(0, 16, SSD1306_WIDTH, SSD1306_HEIGHT - 16, White);
	//start after hall (24) and below PM (15), end at end of xcoord and ycoord of screen
	ssd1306_Clear_region(24, 15, SSD1306_WIDTH, SSD1306_HEIGHT, Black);

}

/**
 * @brief Clear the entire button area.
 *
 * @param None
 *
 * @return None
 */
void oledClearAllButtons_2btn(void)
{
	//SSD1306_DrawFilledRectangle(19, 14, BUTTON_SIZE2 + 16, BUTTON_SIZE2 + 8, Black);
	ssd1306_Clear_region(19, 14, 65, 52, Black);
	//SSD1306_DrawFilledRectangle(65, 14, BUTTON_SIZE2 + 10, BUTTON_SIZE2 + 8, Black);
	ssd1306_Clear_region(65, 14, 105, 52, Black);
}

/**
 * @brief Clears the OLED heat name display.
 *
 * @param None.
 *
 * @return None.
 */
void oledClearHeat(void)
{
	//SSD1306_DrawFilledRectangle(100, 2, 28, 20, Black);
	ssd1306_Clear_region(100, 2, 128, 10, Black);
}

/**
 * @brief Clears the OLED Ref name display.
 *
 * @param None.
 *
 * @return None.
 */
void oledClearRef(void)
{
	//SSD1306_DrawFilledRectangle(0, 2, 20, 8, Black);
	ssd1306_Clear_region(0, 2, 20, 10, Black);
}

/**
 * @brief Clears the OLED Ref delta display.
 *
 * @param None.
 *
 * @return None.
 */
void oledClearRefDelta(void)
{
	//SSD1306_DrawFilledRectangle(20, 2, 25, 8, Black);
	ssd1306_Clear_region(20, 2, 45, 10, Black);
}

/**
 * @brief Clears the OLED Mode name display.
 *
 * @param None.
 *
 * @return None.
 */
void oledClearModeName_2btn(void)
{
	//SSD1306_DrawFilledRectangle(55, 53, 100, 20, Black);
	ssd1306_Clear_region(55, 53, 128, 64, Black);
}

/**
 * @brief Clear Wear text for 2 button.
 *
 * @param None
 *
 * @return None
 */
void oledClearWear(void)
{
	//SSD1306_DrawFilledRectangle(100, 21, 30, 8, Black);
	ssd1306_Clear_region(100, 21, 128, 29, Black);
}

/**
 * @brief Clear Wear Delta for 2 button.
 *
 * @param None
 *
 * @return None
 */
void oledClearWearDelta(void)
{
	//SSD1306_DrawFilledRectangle(100, Y_MIDDLE, 30, 8, Black);
	ssd1306_Clear_region(100, Y_MIDDLE, 128, Y_MIDDLE + 8, Black);
}

/**
 * @brief Clears the OLED PM display.
 *
 * @param None.
 *
 * @return None.
 */
void oledClearPM_2btn(void)
{
	//SSD1306_DrawFilledRectangle(X_MIDDLE - 15, 0, 50, 12, Black);
	ssd1306_Clear_region(X_MIDDLE - 15, 0, X_MIDDLE + 35, 12, Black);
}

/**
 * @brief Clear Dynamic C "SC" or "MC" name, bar line and channel delta for 2 button.
 *
 * @param None
 *
 * @return None
 */
void oledClearDynCbasics(uint8_t xcoord)
{
	//Clear channel type name (SC or MC)
	//SSD1306_DrawFilledRectangle(xcoord, Y_MIDDLE - 19, 12, 10, Black);
	ssd1306_Clear_region(xcoord, Y_MIDDLE - 19, xcoord + 12, Y_MIDDLE - 9, Black);

	//Clear Channel Delta
	//SSD1306_DrawFilledRectangle(xcoord, Y_MIDDLE - 8, 25, 10, Black);
	ssd1306_Clear_region(xcoord, Y_MIDDLE - 8, xcoord + 25, Y_MIDDLE + 2, Black);

	//Clear line on bars
	//SSD1306_DrawFilledRectangle(xcoord - 20, Y_MIDDLE, 20, 1, Black);
	ssd1306_Clear_region(xcoord - 20, Y_MIDDLE, xcoord, Y_MIDDLE + 1, Black);
}

/**
 * @brief Clear Dynamic C touch state for 2 button.
 *
 * @param None
 *
 * @return None
 */
void oledClearDynCState(uint8_t xcoord)
{
	//SSD1306_DrawFilledRectangle(xcoord, 35, 10, 10, Black);
	ssd1306_Clear_region(xcoord, 35, xcoord + 10, 45, Black);
}

/**
 * @brief Clear Dynamic C bar for 2 button.
 *
 * @param None
 *
 * @return None
 */
void oledClearDynCBar(uint8_t xcoord, uint8_t ycoord)
{
	//SSD1306_DrawFilledRectangle(xcoord + 6, ycoord, 8, 21, Black);
	ssd1306_Clear_region(xcoord + 6, ycoord, xcoord + 14, ycoord + 21, Black);
}

/**
 * @brief Check what the function of the button is based on the board state.
 *
 * @param None.
 *
 * @return None.
 */
void doBtnModeFunction_2btn(void)
{
	/* Skip the startup routine if it is currently running. */
	if (demo.startup_2btn_state < startup_2btn_end)
	{
		demo.startup_2btn_state = startup_2btn_clearAll;
	}
	else
	{
		switch(mode_Wear_DynC)
		{

		case wear: 											//if currently in wear detect mode, switch to dynamic C
			delta.prev_deltach1 = 0;						//create current state for ch1 (MC) to ensure that graph is drawn if the mode switches while a touch is present
			delta.prev_deltach4 = 0;						//create current state for ch4 (SC) to ensure that graph is drawn if the mode switches while a touch is present

			oledClearModeSwitch();							//Clear screen (not PM) using a more efficient function than draw filled rectangle

			mode_Wear_DynC = dynC;							//current mode is now dynamic C

			mode.current.wear = false;
			mode.current.dyC = true;

			disable_ref();									//disable ref
			disable_heat();									//disable heat

			oledDisplayText_2btn("Mode: Dynamic C", 25, 53, Font_6x8, White);
			/* To fix the tail of the y character being cut off. */
			SSD1306_DrawLine(68, 60, 70, 60, White);

			Ref_Heat_State = ref_state;						//disable heat and reference when mode switches
			break;

		case dynC:											//if currently in dynamic C mode, switch to wear detect
			buttons.button[0].state = b_2btn_none;				//create a current state for button 0 to ensure that it is drawn if the mode switches while a touch is present
			buttons.button[1].state = b_2btn_none;				//create a current state for button 1 to ensure that it is drawn if the mode switches while a touch is present

			oledClearModeSwitch();

			mode_Wear_DynC = wear;							//current mode is now wear

			mode.current.wear = true;
			mode.current.dyC = false;

			disable_ref();									//disable ref
			disable_heat();									//disable heat

			oledDisplayText_2btn("Mode: Default", 25, 53, Font_6x8, White);

			Ref_Heat_State = ref_state;						//disable heat and reference when mode switches
			break;
		}
	}
}

/**
 * @brief Check what the function of the button is based on the board state.
 *
 * @param None.
 *
 * @return None.
 */
void doBtn1Function_2btn(void)
{
	switch (Ref_Heat_State)
	{
	case ref_state:															//startup in this state, only implemented when button is pressed

		oledClearRefDelta();
		oledDisplayText_2btn("REF", 2, 2, Font_6x8, White);
		ref_flag = true;
		iqs269_setRefChannel(0xB5, 0x10, I2C_STOP);							//enable reference
		Ref_Heat_State = heat_state;										//enable heat when button is pressed again

		break;

	case heat_state:														//enable heat when button is pressed

		oledDisplayText_2btn("HEAT", 100, 2, Font_6x8, White);
		LL_GPIO_SetOutputPin(HEAT_PORT, HEAT_PIN);							//enable heat
		Ref_Heat_State = heat_disabled_state;								//disable heat when button is pressed again

		break;

	case heat_disabled_state:												//reference still on from heat_state but heat disabled, next state is reference off

		disable_heat();														//disable heat
		Ref_Heat_State = no_ref_state;										//disable ref when button is pressed again

		break;

	case no_ref_state:														//reference and heat off

		disable_ref();														//disable reference
		Ref_Heat_State = ref_state;											//enable ref when button is pressed again

		break;

	default:
		break;
	}
	demo.update = true;
}

/**
 * @brief Displays the Delta parameter on the OLED display at x position.
 *
 * @param uint8_t : \b x - x coordinate of the center line.
 * @param int16_t : \b delta - Delta number to draw the bar with.
 * @param int16_t : \b displayDelta - Delta number to display below bar.
 *
 * @retval None.
 */
void oledBar_Hall(uint8_t x, int16_t delta, int16_t displayDelta)
{
	int16_t difference;
	char dispBuff1[64];

	if ((hall.prev_delta > 0) && (delta < 0))
	{
		// clear the positive bar area
		//SSD1306_DrawFilledRectangle(x+6, Y_MIDDLE - 21, 8, 21, Black);
		ssd1306_Clear_region(x + 6, Y_MIDDLE - 21, x + 15, Y_MIDDLE, Black);
	}
	else if((hall.prev_delta < 0) && (delta > 0))
	{
		// clear the negative bar area
		//SSD1306_DrawFilledRectangle(x+6, Y_MIDDLE, 8, 21, Black);
		ssd1306_Clear_region(x + 6, Y_MIDDLE, x + 15, Y_MIDDLE + 21, Black);
	}
	else if ((delta == 0) || (pm.state == pm_2btn_ulp))
	{
		//SSD1306_DrawFilledRectangle(x+6, Y_MIDDLE - 3, 8, 6, Black);
		ssd1306_Clear_region(x + 6, Y_MIDDLE - 3, x + 15, Y_MIDDLE + 3, Black);
	}

	//clear delta
	//SSD1306_DrawFilledRectangle(x, 54, 23, 64, Black);
	ssd1306_Clear_region(x, 54, x + 24, 64, Black);

	// Display the delta value
	oledDisplayText_2btn(itoa((abs(displayDelta)), dispBuff1, 10), x, 54, Font_6x8, White);

	if (delta / 3 > 21) //Just to control the max
	{
		delta = 21 * 3;
	}
	else if (delta / 3 < -21)
	{
		delta = -21 * 3;
	}

	if (delta > 0)
	{
		if ((hall.prev_delta > delta) ) //&& ((delta/3) >= 1)
		{
			//only clear the difference
			difference = hall.prev_delta - delta;
			//SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE - (hall.prev_delta / 3), 8, (difference / 3), Black);
			ssd1306_Clear_region(x + 6, Y_MIDDLE - (hall.prev_delta / 3), x + 15, (Y_MIDDLE - (hall.prev_delta / 3)) + (difference / 3) + 1, Black);

		}
		else // delta greater than prev delta
		{
			//only draw the difference
			difference = delta - hall.prev_delta;

			/* The bar will sometimes miss one row of pixels. Check this condition to fix this bug. */
			if (delta > 5)
			{
				SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE - (delta / 3), 8, (difference / 3)+1, White);
			}
			else
			{
				SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE - (delta / 3), 8, (difference / 3), White);
			}
		}

		if ((delta > 10))
		{
			oledDisplayText_2btn("+", x, Y_MIDDLE - 10, Font_6x8, White);
		}
		else
		{
			//Clear the plus sign
			//SSD1306_DrawFilledRectangle(x, Y_MIDDLE - 10, 4, 6, Black);
			ssd1306_Clear_region(x, Y_MIDDLE - 10, x + 6, Y_MIDDLE - 4, Black);
		}
	}
	else //delta smaller than 0
	{
		if ((hall.prev_delta < delta))
		{
			difference = hall.prev_delta - delta;
			//SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE + (abs(delta) / 3), 8, (abs(difference / 3))+1, Black);
			ssd1306_Clear_region(x + 6, Y_MIDDLE + (abs(delta) / 3), x + 15, (Y_MIDDLE + (abs(delta) / 3)) + ((abs(difference / 3))+2), Black);
		}
		else
		{
			difference = delta - hall.prev_delta;
			SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE + (abs(hall.prev_delta / 3)), 8, (abs(difference) / 3), White);
		}

		if ((delta < -10))
		{
			oledDisplayText_2btn("-", x, Y_MIDDLE + 5, Font_6x8, White);
		}
		else
		{
			//Clear the minus sign
			//SSD1306_DrawFilledRectangle(x, Y_MIDDLE + 5, 4, 6, Black);
			ssd1306_Clear_region(x, Y_MIDDLE + 5, x + 6, Y_MIDDLE + 11, Black);
		}
	}
	//center line
	SSD1306_DrawLine(x, Y_MIDDLE, x + 19, Y_MIDDLE, White);
	hall.prev_delta = delta;
}

/**
 * @brief Displays the Delta parameter on the OLED display at x position.
 *
 * @param uint8_t : \b x - x coordinate of the center line.
 * @param int16_t : \b delta - Delta number to draw the bar with.
 * @param int16_t : \b prevdelta - Value of previous delta
 *
 * @retval None.
 */
void oledBar2btn(uint8_t x, int16_t delta, int16_t prevdelta)
{
	char dispBuff1[64];
	int16_t difference;

	if((prevdelta >0) && (delta < 0))
	{
		// clear the positive bar area
		SSD1306_DrawFilledRectangle(x+6, Y_MIDDLE - 18, 8, 20, Black);
	}

	else if((prevdelta < 0) && (delta > 0))
	{
		// clear the negative bar area
		SSD1306_DrawFilledRectangle(x+6, Y_MIDDLE, 8, 20, Black);
	}

	else if ((delta == 0))
	{
		SSD1306_DrawFilledRectangle(x+6, Y_MIDDLE - 20, 8, 40, Black);
	}


	//clear delta
	SSD1306_DrawFilledRectangle(x+20, Y_MIDDLE - 8, 28, 10, Black);

	// Display the delta value
	oledDisplayText_2btn(itoa(delta, dispBuff1, 10), x+20, Y_MIDDLE - 8, Font_6x8, White);


	if (delta / 18 > 20) //Just to control the max
	{
		delta = 20 * 18;
	}
	else if (delta / 18 < -20)
	{
		delta = -20 * 18;
	}

	if (prevdelta / 18 > 20) //Just to control the max
	{
		prevdelta = 20 * 18;
	}
	else if (prevdelta / 18 < -20)
	{
		prevdelta = -20 * 18;
	}
	if (delta >= 0) //delta >= 0
	{
		if ((prevdelta > delta) )
		{	//&& ((delta/3) >= 1)
			//only clear the difference
			difference = prevdelta - delta;
			SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE - (prevdelta / 18), 8, (difference / 18), Black);
		}
		else // delta greater than prev delta
		{
			//only draw the difference
			difference = delta - prevdelta;

			// The bar will sometimes miss one row of pixels. Check this condition to fix this bug.
//			if(delta > 18)
//			{
//				SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE - (delta / 18), 8, (difference / 18) + 1, White);
//			}
//			else
//			{
				SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE - (delta / 18), 8, (delta / 18), White);
//			}

		}
	}
	else //delta smaller than 0
	{
		if ((prevdelta < delta))
		{
			difference = prevdelta - delta;
			SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE + (abs(delta) / 18), 8, (abs(difference / 18))+1, Black);
		}
		else
		{
			difference = delta - prevdelta;
			//SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE + (abs(prevdelta / 18)), 8, (abs(difference) / 18), White);
			SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE, 8, (abs(delta) / 18), White);
		}
	}
	//center line
	SSD1306_DrawLine(x, Y_MIDDLE, x + 20, Y_MIDDLE, White);
}

/**
 *  @brief Disable reference channel
 *
 * @param None.
 *
 * @return None.
 */
void disable_ref(void)
{
	ref_flag = false;
	oledClearRef();
	oledClearRefDelta();
	oledClearHeat();
	iqs269_setRefChannel(0xB5, 0x00, I2C_STOP);							//disable reference channel
}

/**
 * @brief Disable heat
 *
 * @param None.
 *
 * @return None.
 */
void disable_heat(void)
{
	LL_GPIO_ResetOutputPin(HEAT_PORT, HEAT_PIN);
	oledClearHeat();
	//disable heat pin
}


/**
 * @brief Determine state of channel and display state accordingly
 *
 * @param uint8_t : xCoord -  Specifies the x coordinate of the cursor.
 * @param uint8_t : ch_x -  Specifies the channel of which the state must be evaluated
 *
 * @return None
 */
void touch_state_dynC(uint8_t ch_x, uint8_t xcoord)
{
	if (iqs269_Channel_DeepTouchState(ch_x))
	{
		oledClearDynCState(xcoord);
		oledDisplayText_2btn("D", xcoord, 35, Font_6x8, White);
	}

	else if (iqs269_Channel_TouchState(ch_x))
	{
		oledClearDynCState(xcoord);
		oledDisplayText_2btn("T", xcoord, 35, Font_6x8, White);
	}

	else if (iqs269_Channel_ProxState(ch_x))
	{
		oledClearDynCState(xcoord);
		oledDisplayText_2btn("P", xcoord, 35, Font_6x8, White);
	}

	else //None
	{
		oledClearDynCState(xcoord);
	}
}

/**
 * @brief  		Initialize the pointer to the iqs269 instance
 *
 * @param  	iqs269_s* : \b iqs269 - Pointer to iqs269 instance
 *
 * @return 		None
 */
void iqs269_pointer_init_2btn(iqs269_s *iqs269)
{
	_iqs269Ptr2 = iqs269;
}

