
/*** Includes ***/
#include "main.h"
#include "draw.h"
#include "AZQ_util.h"
#include "iqs269.h"
#include "ftoa.h"
#include "demo_8btn.h"
#include "IQS269A_settings_8btn.h"

demo_8btn_s demo;
hall_8btn_s hall;
gestures_s gestures;
buttons_8btn_s buttons;
coordinates_s coordinates;
pm_8btn_s pm;
abscap_s abscap;
iqs269_s *_iqs269Ptr8;

Mode_8btn_t mode;

uint8_t count;
uint32_t timerGesture;
short abs_channel = 0;

bool firstTouch = false;
bool firstHallEvent = false;

/**
 * @brief Configure settings for IQS269 8 Button demo
 *
 * @param None
 *
 * @retval None
 */
void Configure_demo_8btn(void)
{
	/* Configure the coordinates and numbers of the touch pad buttons. */
		buttons.button[B1].button_number = 	1;
		buttons.button[B1].xCoord = 20;
		buttons.button[B1].yCoord = 14;

		buttons.button[B2].button_number = 2;
		buttons.button[B2].xCoord = 40;
		buttons.button[B2].yCoord = 14;

		buttons.button[B3].button_number = 3;
		buttons.button[B3].xCoord = 60;
		buttons.button[B3].yCoord = 14;

		buttons.button[B4].button_number = 4;
		buttons.button[B4].xCoord = 80;
		buttons.button[B4].yCoord = 14;

		buttons.button[B5].button_number = 5;
		buttons.button[B5].xCoord = 20;
		buttons.button[B5].yCoord = 34;

		buttons.button[B6].button_number = 6;
		buttons.button[B6].xCoord = 40;
		buttons.button[B6].yCoord = 34;

		buttons.button[B7].button_number = 7;
		buttons.button[B7].xCoord = 60;
		buttons.button[B7].yCoord = 34;

		buttons.button[B8].button_number = 8;
		buttons.button[B8].xCoord = 80;
		buttons.button[B8].yCoord = 34;

		mode.previous.touch = false;
		mode.previous._8btn = false;
		mode.previous.abscap = false;
		mode.previous.draw = false;
}

/**
 @brief Reset the states of the 8btn demo state machines
 *
 * @param None
 *
 * @retval None
 */
void reset_demo_8btn(void)
{
	demo.startup_state = startup_begin;
	demo.run_state = demo_run_startup;
	firstTouch = false;
	init_settings_8btn();
	_iqs269Ptr8->state = IQS269_STATE_NONE;
	_iqs269Ptr8->init_state = IQS269_INIT_INTERFACE;

}

void init_settings_8btn(void)
{

		// Addresses 0x80 Byte0 to 0x85 Byte1.

		_iqs269Ptr8->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_pmu_general_settings 		= PMU_GENERAL_SETTINGS;
		_iqs269Ptr8->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_i2c_general_settings 		= I2C_GENERAL_SETTINGS;
		_iqs269Ptr8->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_sys_chb_active 			= SYS_CHB_ACTIVE;
		_iqs269Ptr8->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_acf_lta_filter_settings 	= ACF_LTA_FILTER_SETTINGS;
		_iqs269Ptr8->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_lta_chb_reseed_enabled 	= LTA_CHB_RESEED_ENABLED;
		_iqs269Ptr8->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_uis_global_events_mask 	= UIS_GLOBAL_EVENTS_MASK;
		_iqs269Ptr8->IQSMemoryMap.iqs269_rep_timing.iqs269_pmu_report_rate_np 				= PMU_REPORT_RATE_NP;
		_iqs269Ptr8->IQSMemoryMap.iqs269_rep_timing.iqs269_pmu_report_rate_lp 				= PMU_REPORT_RATE_LP;
		_iqs269Ptr8->IQSMemoryMap.iqs269_rep_timing.iqs269_pmu_report_rate_ulp				= PMU_REPORT_RATE_ULP;
		_iqs269Ptr8->IQSMemoryMap.iqs269_rep_timing.iqs269_pmu_mode_timout					= PMU_MODE_TIMOUT;
		_iqs269Ptr8->IQSMemoryMap.iqs269_rep_timing.iqs269_i2c_window_timeout 				= I2C_WINDOW_TIMEOUT;
		_iqs269Ptr8->IQSMemoryMap.iqs269_rep_timing.iqs269_lta_halt_timeout 				= LTA_HALT_TIMEOUT;
		_iqs269Ptr8->IQSMemoryMap.iqs269_global_settings.iqs269_general_settings0			= PXS_GENERAL_SETTINGS0;
		_iqs269Ptr8->IQSMemoryMap.iqs269_global_settings.iqs269_general_settings1			= PXS_GENERAL_SETTINGS1;
		_iqs269Ptr8->IQSMemoryMap.iqs269_global_settings.iqs269_abs_cap_settings			= UIS_ABSOLUTE_CAPACITANCE;
		_iqs269Ptr8->IQSMemoryMap.iqs269_global_settings.iqs269_ref_chan_gensetting			= UIS_DCF_GENERAL_SETTINGS;
		_iqs269Ptr8->IQSMemoryMap.iqs269_global_settings.iqs269_ev_block					= GEM_CHB_BLOCK_NFOLLOW;
		_iqs269Ptr8->IQSMemoryMap.iqs269_global_settings.iqs269_gen_res7					= MOV_CHB_MOVEMENT_CHANNEL;
		_iqs269Ptr8->IQSMemoryMap.iqs269_global_settings.iqs269_chan_sel_slid0				= UIS_CHB_SLIDER0;
		_iqs269Ptr8->IQSMemoryMap.iqs269_global_settings.iqs269_chan_sel_slid1				= UIS_CHB_SLIDER1;
		_iqs269Ptr8->IQSMemoryMap.iqs269_global_settings.iqs269_tap_timout_slid				= UIS_GESTURE_TAP_TIMEOUT;
		_iqs269Ptr8->IQSMemoryMap.iqs269_global_settings.iqs269_swipe_timout_slid			= UIS_GESTURE_SWIPE_TIMEOUT;
		_iqs269Ptr8->IQSMemoryMap.iqs269_global_settings.iqs269_swipe_thres_slid			= UIS_GESTURE_THRESHOLD;
		_iqs269Ptr8->IQSMemoryMap.iqs269_global_settings.iqs269_chb_reseed_en				= LTA_CHB_RESEED;

		/* Channel 0 Settings - Read/Write */
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_crxsel_ch0 				=  PXS_CRXSEL_CH0;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_ctxsel_ch0 				=  PXS_CTXSEL_CH0;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_proxctrl_ch0 				=  PXS_PROXCTRL_CH0;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_proxcfg0_ch0 				=  PXS_PROXCFG0_CH0 ;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_proxcfg1_testreg0_ch0		=  PXS_PROXCFG1_TESTREG0_CH0;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch0_settings.iqs269_ati_base_and_target_ch0		=  ATI_BASE_AND_TARGET_CH0;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch0_settings.iqs269_ati_mirror_ch0 				=  ATI_MIRROR_CH0;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch0_settings.iqs269_ati_pcc_ch0 					=  ATI_PCC_CH0;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_prox_threshold_ch0 		=  PXS_PROX_THRESHOLD_CH0;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_touch_threshold_ch0 		=  PXS_TOUCH_THRESHOLD_CH0;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_deep_threshold_ch0 		=  PXS_DEEP_THRESHOLD_CH0;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_hysteresis_ch0 			=  PXS_HYSTERESIS_CH0;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch0_settings.iqs269_dcf_chb_association_ch0 		=  DCF_CHB_ASSOCIATION_CH0;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch0_settings.iqs269_dcf_weight_ch0 				=  DCF_WEIGHT_CH0;

		/* Channel 1 Settings - Read/Write */
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_crxsel_ch1 				=  PXS_CRXSEL_CH1;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_ctxsel_ch1 				=  PXS_CTXSEL_CH1;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_proxctrl_ch1 				=  PXS_PROXCTRL_CH1;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_proxcfg0_ch1 				=  PXS_PROXCFG0_CH1;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_proxcfg1_testreg0_ch1		=  PXS_PROXCFG1_TESTREG0_CH1;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch1_settings.iqs269_ati_base_and_target_ch1		=  ATI_BASE_AND_TARGET_CH1;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch1_settings.iqs269_ati_mirror_ch1 				=  ATI_MIRROR_CH1;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch1_settings.iqs269_ati_pcc_ch1 					=  ATI_PCC_CH1;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_prox_threshold_ch1 		=  PXS_PROX_THRESHOLD_CH1;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_touch_threshold_ch1 		=  PXS_TOUCH_THRESHOLD_CH1;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_deep_threshold_ch1 		=  PXS_DEEP_THRESHOLD_CH1;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_hysteresis_ch1 			=  PXS_HYSTERESIS_CH1;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch1_settings.iqs269_dcf_chb_association_ch1 		=  DCF_CHB_ASSOCIATION_CH1;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch1_settings.iqs269_dcf_weight_ch1 				=  DCF_WEIGHT_CH1;

		/* Channel 2 Settings - Read/Write */
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_crxsel_ch2 				=  PXS_CRXSEL_CH2;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_ctxsel_ch2 				=  PXS_CTXSEL_CH2;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_proxctrl_ch2 				=  PXS_PROXCTRL_CH2;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_proxcfg0_ch2 				=  PXS_PROXCFG0_CH2;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_proxcfg1_testreg0_ch2		=  PXS_PROXCFG1_TESTREG0_CH2;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch2_settings.iqs269_ati_base_and_target_ch2		=  ATI_BASE_AND_TARGET_CH2;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch2_settings.iqs269_ati_mirror_ch2 				=  ATI_MIRROR_CH2;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch2_settings.iqs269_ati_pcc_ch2 					=  ATI_PCC_CH2;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_prox_threshold_ch2 		=  PXS_PROX_THRESHOLD_CH2;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_touch_threshold_ch2 		=  PXS_TOUCH_THRESHOLD_CH2;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_deep_threshold_ch2			=  PXS_DEEP_THRESHOLD_CH2;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_hysteresis_ch2 			=  PXS_HYSTERESIS_CH2;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch2_settings.iqs269_dcf_chb_association_ch2 		=  DCF_CHB_ASSOCIATION_CH2;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch2_settings.iqs269_dcf_weight_ch2 				=  DCF_WEIGHT_CH2;

		/* Channel 3 Settings - Read/Write */
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_crxsel_ch3 				=  PXS_CRXSEL_CH3;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_ctxsel_ch3 				=  PXS_CTXSEL_CH3;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_proxctrl_ch3 				=  PXS_PROXCTRL_CH3;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_proxcfg0_ch3 				=  PXS_PROXCFG0_CH3;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_proxcfg1_testreg0_ch3		=  PXS_PROXCFG1_TESTREG0_CH3;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch3_settings.iqs269_ati_base_and_target_ch3		=  ATI_BASE_AND_TARGET_CH3;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch3_settings.iqs269_ati_mirror_ch3 				=  ATI_MIRROR_CH3;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch3_settings.iqs269_ati_pcc_ch3 					=  ATI_PCC_CH3;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_prox_threshold_ch3 		=  PXS_PROX_THRESHOLD_CH3;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_touch_threshold_ch3 		=  PXS_TOUCH_THRESHOLD_CH3;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_deep_threshold_ch3			=  PXS_DEEP_THRESHOLD_CH3;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_hysteresis_ch3 			=  PXS_HYSTERESIS_CH3;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch3_settings.iqs269_dcf_chb_association_ch3 		=  DCF_CHB_ASSOCIATION_CH3;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch3_settings.iqs269_dcf_weight_ch3 				=  DCF_WEIGHT_CH3;

		/* Channel 4 Settings - Read/Write */
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_crxsel_ch4 				=  PXS_CRXSEL_CH4;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_ctxsel_ch4 				=  PXS_CTXSEL_CH4;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_proxctrl_ch4 				=  PXS_PROXCTRL_CH4;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_proxcfg0_ch4 				=  PXS_PROXCFG0_CH4;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_proxcfg1_testreg0_ch4		=  PXS_PROXCFG1_TESTREG0_CH4;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch4_settings.iqs269_ati_base_and_target_ch4		=  ATI_BASE_AND_TARGET_CH4;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch4_settings.iqs269_ati_mirror_ch4 				=  ATI_MIRROR_CH4;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch4_settings.iqs269_ati_pcc_ch4 					=  ATI_PCC_CH4;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_prox_threshold_ch4 		=  PXS_PROX_THRESHOLD_CH4;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_touch_threshold_ch4 		=  PXS_TOUCH_THRESHOLD_CH4;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_deep_threshold_ch4			=  PXS_DEEP_THRESHOLD_CH4;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_hysteresis_ch4 			=  PXS_HYSTERESIS_CH4;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch4_settings.iqs269_dcf_chb_association_ch4 		=  DCF_CHB_ASSOCIATION_CH4;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch4_settings.iqs269_dcf_weight_ch4 				=  DCF_WEIGHT_CH4;

		/* Channel 5 Settings - Read/Write */
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_crxsel_ch5 				=  PXS_CRXSEL_CH5;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_ctxsel_ch5 				=  PXS_CTXSEL_CH5;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_proxctrl_ch5 				=  PXS_PROXCTRL_CH5;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_proxcfg0_ch5 				=  PXS_PROXCFG0_CH5;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_proxcfg1_testreg0_ch5		=  PXS_PROXCFG1_TESTREG0_CH5;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch5_settings.iqs269_ati_base_and_target_ch5		=  ATI_BASE_AND_TARGET_CH5;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch5_settings.iqs269_ati_mirror_ch5 				=  ATI_MIRROR_CH5;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch5_settings.iqs269_ati_pcc_ch5 					=  ATI_PCC_CH5;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_prox_threshold_ch5 		=  PXS_PROX_THRESHOLD_CH5;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_touch_threshold_ch5 		=  PXS_TOUCH_THRESHOLD_CH5;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_deep_threshold_ch5			=  PXS_DEEP_THRESHOLD_CH5;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_hysteresis_ch5 			=  PXS_HYSTERESIS_CH5;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch5_settings.iqs269_dcf_chb_association_ch5 		=  DCF_CHB_ASSOCIATION_CH5;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch5_settings.iqs269_dcf_weight_ch5 				=  DCF_WEIGHT_CH5;

		/* Channel 6 Settings - Read/Write */
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_crxsel_ch6 				=  PXS_CRXSEL_CH6;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_ctxsel_ch6 				=  PXS_CTXSEL_CH6;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_proxctrl_ch6 				=  PXS_PROXCTRL_CH6;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_proxcfg0_ch6 				=  PXS_PROXCFG0_CH6;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_proxcfg1_testreg0_ch6		=  PXS_PROXCFG1_TESTREG0_CH6;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch6_settings.iqs269_ati_base_and_target_ch6		=  ATI_BASE_AND_TARGET_CH6;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch6_settings.iqs269_ati_mirror_ch6 				=  ATI_MIRROR_CH6;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch6_settings.iqs269_ati_pcc_ch6 					=  ATI_PCC_CH6;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_prox_threshold_ch6 		=  PXS_PROX_THRESHOLD_CH6;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_touch_threshold_ch6 		=  PXS_TOUCH_THRESHOLD_CH6;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_deep_threshold_ch6			=  PXS_DEEP_THRESHOLD_CH6;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_hysteresis_ch6 			=  PXS_HYSTERESIS_CH6;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch6_settings.iqs269_dcf_chb_association_ch6 		=  DCF_CHB_ASSOCIATION_CH6;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch6_settings.iqs269_dcf_weight_ch6 				=  DCF_WEIGHT_CH6;

		/* Channel 7 Settings - Read/Write */
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_crxsel_ch7 				=  PXS_CRXSEL_CH7;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_ctxsel_ch7 				=  PXS_CTXSEL_CH7;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_proxctrl_ch7 				=  PXS_PROXCTRL_CH7;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_proxcfg0_ch7 				=  PXS_PROXCFG0_CH7;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_proxcfg1_testreg0_ch7		=  PXS_PROXCFG1_TESTREG0_CH7;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch7_settings.iqs269_ati_base_and_target_ch7		=  ATI_BASE_AND_TARGET_CH7;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch7_settings.iqs269_ati_mirror_ch7 				=  ATI_MIRROR_CH7;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch7_settings.iqs269_ati_pcc_ch7 					=  ATI_PCC_CH7;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_prox_threshold_ch7 		=  PXS_PROX_THRESHOLD_CH7;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_touch_threshold_ch7 		=  PXS_TOUCH_THRESHOLD_CH7;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_deep_threshold_ch7			=  PXS_DEEP_THRESHOLD_CH7;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_hysteresis_ch7 			=  PXS_HYSTERESIS_CH7;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch7_settings.iqs269_dcf_chb_association_ch7 		=  DCF_CHB_ASSOCIATION_CH7;
		_iqs269Ptr8->IQSMemoryMap.iqs269_ch7_settings.iqs269_dcf_weight_ch7 				=  DCF_WEIGHT_CH7;
}

/**
 @brief Run the startup routine for the 8btn demo board
 *
 * @param None
 *
 * @retval None
 */
void run_demoStartupRoutine_8btn(void){
	switch (demo.startup_state) {
	case startup_begin:
		if (ssd1306_CheckScreenReady(0)) {
			oledClear();
			/* Display the Azoteq splash logo. */
			ssd1306_LoadLogo();
			demo.startup_state = startup_NP;
		}
		break;

		/*		PM demonstrations		*/
	case startup_NP:
		if (ssd1306_CheckScreenReady(1000)) {
			oledClear();
			fillRoundRect(X_MIDDLE - 15, 1, 15, 10, 2, White);
			oledDisplayText("NP", X_MIDDLE - 13, 2, Font_6x8, Black);
			demo.startup_state = startup_LP;
		}
		break;
	case startup_LP:
		if (ssd1306_CheckScreenReady(500)) {
			oledClearPM();
			fillRoundRect(X_MIDDLE - 15, 1, 15, 10, 2, White);
			oledDisplayText("LP", X_MIDDLE - 13, 2, Font_6x8, Black);
			demo.startup_state = startup_ULP;
		}
		break;
	case startup_ULP:
		if (ssd1306_CheckScreenReady(500)) {
			oledClearPM();
			fillRoundRect(X_MIDDLE - 15, 1, 20, 10, 2, White);
			oledDisplayText("ULP", X_MIDDLE - 13, 2, Font_6x8, Black);
			demo.startup_state = startup_FUNC;
		}
		break;

		/*		Display FUNC on OLED		*/
	case startup_FUNC:
		if (ssd1306_CheckScreenReady(500)) {
			oledClearPM();
			oledDisplayText("FUNC", 100, 2, Font_6x8, White);
			demo.startup_state = startup_ABS;
		}
		break;
	case startup_ABS:
		if (ssd1306_CheckScreenReady(500)) {
			oledClearFunc();
			oledDisplayText("ABS", 100, 2, Font_6x8, White);
			demo.startup_state = startup_8btn;
		}
		break;
	case startup_8btn:
		if (ssd1306_CheckScreenReady(500)) {
			oledClearFunc();
			oledDisplayText("8btn", 100, 2, Font_6x8, White);
			demo.startup_state = startup_B1;
		}
		break;

		/*		Gestures Demonstration		*/
		/*		Right Swipe					*/
	case startup_B1:
		if (ssd1306_CheckScreenReady(500)) {
			oledClearFunc();
			oledDrawButton_8btn("1", buttons.button[B1].xCoord, buttons.button[B1].yCoord, Font_6x8, White, b_touch);
			demo.startup_state = startup_B2;
		}
		break;
	case startup_B2:
		if (ssd1306_CheckScreenReady(100)) {
			oledDrawButton_8btn("2", buttons.button[B2].xCoord, buttons.button[B2].yCoord, Font_6x8, White, b_touch);
			demo.startup_state = startup_B3;
		}
		break;
	case startup_B3:
		if (ssd1306_CheckScreenReady(100)) {
			oledDrawButton_8btn("3", buttons.button[B3].xCoord, buttons.button[B3].yCoord, Font_6x8, White, b_touch);
			demo.startup_state = startup_B4;
		}
		break;
	case startup_B4:
		if (ssd1306_CheckScreenReady(100)) {
			oledDrawButton_8btn("4", buttons.button[B4].xCoord, buttons.button[B4].yCoord, Font_6x8, White, b_touch);
			demo.startup_state = startup_gesture_R;
		}
		break;
	case startup_gesture_R:
		if (ssd1306_CheckScreenReady(100)) {
			//draw right arrow
			SSD1306_DrawFilledRectangle(103, 33, 12, 2, White);
			SSD1306_DrawFilledTriangle(116, 37, 116, 31, 123, 34, White);
			demo.startup_state = startup_B8;
		}
		break;

		/*		Left Swipe		*/
	case startup_B8:
		if (ssd1306_CheckScreenReady(500)) {
			oledClearButton(buttons.button[B1].xCoord, buttons.button[B1].yCoord, BUTTON_SIZE, Black);
			oledClearButton(buttons.button[B2].xCoord, buttons.button[B2].yCoord, BUTTON_SIZE, Black);
			oledClearButton(buttons.button[B3].xCoord, buttons.button[B3].yCoord, BUTTON_SIZE, Black);
			oledClearButton(buttons.button[B4].xCoord, buttons.button[B4].yCoord, BUTTON_SIZE, Black);
			oledClearGesture();
			oledDrawButton_8btn("8", buttons.button[B8].xCoord, buttons.button[B8].yCoord, Font_6x8, White, b_touch);
			demo.startup_state = startup_B7;
		}
		break;
	case startup_B7:
		if (ssd1306_CheckScreenReady(100)) {
			oledDrawButton_8btn("7", buttons.button[B7].xCoord, buttons.button[B7].yCoord, Font_6x8, White, b_touch);
			demo.startup_state = startup_B6;
		}
		break;
	case startup_B6:
		if (ssd1306_CheckScreenReady(100)) {
			oledDrawButton_8btn("6", buttons.button[B6].xCoord, buttons.button[B6].yCoord, Font_6x8, White, b_touch);
			demo.startup_state = startup_B5;
		}
		break;
	case startup_B5:
		if (ssd1306_CheckScreenReady(100)) {
			oledDrawButton_8btn("5", buttons.button[B5].xCoord, buttons.button[B5].yCoord, Font_6x8, White, b_touch);
			demo.startup_state = startup_gesture_L;
		}
		break;
	case startup_gesture_L:
		if (ssd1306_CheckScreenReady(100)) {
			oledClearGesture();
			// draw left arrow
			SSD1306_DrawFilledRectangle(111, 33, 12, 2, White);
			SSD1306_DrawFilledTriangle(111, 37, 111, 31, 104, 34, White);
			demo.startup_state = startup_tap_B2;
		}
		break;

		/*		Tap Gesture		*/
	case startup_tap_B2:
		if (ssd1306_CheckScreenReady(500)) {
			oledClearGesture();
			oledClearAllButtons();
			oledDrawButton_8btn("2", buttons.button[B2].xCoord, buttons.button[B2].yCoord, Font_6x8, White, b_prox);
			demo.startup_state = startup_tap_Rect1;
		}
		break;

	case startup_tap_Rect1:
		if (ssd1306_CheckScreenReady(200)) {
			drawRoundRect(42, 16, BUTTON_SIZE - 4, BUTTON_SIZE - 4, 3, White);
			demo.startup_state = startup_tap_Rect2;
		}
		break;
	case startup_tap_Rect2:
		if (ssd1306_CheckScreenReady(200)) {
			drawRoundRect(40, 14, BUTTON_SIZE, BUTTON_SIZE, 5, White);
			demo.startup_state = startup_tap_clear;
		}
		break;
	case startup_tap_clear:
		if (ssd1306_CheckScreenReady(300)) {
			oledClearAllButtons();
			demo.startup_state = startup_tap_tap;
		}
		break;

	case startup_tap_tap:
		if (ssd1306_CheckScreenReady(100)) {
			oledDisplayText(" tap", 101, 30, Font_6x8, White);
			demo.startup_state = startup_up_B6;
		}
		break;

		/*		Up Swipe		*/
	case startup_up_B6:
		if (ssd1306_CheckScreenReady(500)) {
			oledClearAllButtons();
			oledClearGesture();
			oledDrawButton_8btn("6", buttons.button[B6].xCoord, buttons.button[B6].yCoord, Font_6x8, White, b_touch);
			demo.startup_state = startup_up_B2;
		}
		break;
	case startup_up_B2:
		if (ssd1306_CheckScreenReady(250)) {
			oledDrawButton_8btn("2", buttons.button[B2].xCoord, buttons.button[B2].yCoord, Font_6x8, White, b_touch);
			demo.startup_state = startup_up_clearB6;
		}
		break;
	case startup_up_clearB6:
		if (ssd1306_CheckScreenReady(250)) {
			oledClearButton(buttons.button[B6].xCoord, buttons.button[B6].yCoord, BUTTON_SIZE, Black);
			demo.startup_state = startup_up_clearB2;
		}
		break;
	case startup_up_clearB2:
		if (ssd1306_CheckScreenReady(250)) {
			oledClearButton(buttons.button[B2].xCoord, buttons.button[B2].yCoord, BUTTON_SIZE, Black);
			demo.startup_state = startup_up_up;
		}
		break;
	case startup_up_up:
		if (ssd1306_CheckScreenReady(100)) {
			//draw up arrow
			SSD1306_DrawFilledRectangle(114, 37, 2, 12, White);
			SSD1306_DrawFilledTriangle(112, 37, 115, 30, 118, 37, White);
			ssd1306_DrawPixel(114, 34, White);		//random black pixel
			demo.startup_state = startup_dwn_B3;
		}
		break;

		/*		Down Swipe		*/
	case startup_dwn_B3:
		if (ssd1306_CheckScreenReady(500)) {
			oledClearAllButtons();
			oledClearGesture();
			oledDrawButton_8btn("3", buttons.button[B3].xCoord, buttons.button[B3].yCoord, Font_6x8, White, b_touch);
			demo.startup_state = startup_dwn_B7;
		}
		break;
	case startup_dwn_B7:
		if (ssd1306_CheckScreenReady(250)) {
			oledDrawButton_8btn("7", buttons.button[B7].xCoord, buttons.button[B7].yCoord, Font_6x8, White, b_touch);
			demo.startup_state = startup_dwn_clearB3;
		}
		break;
	case startup_dwn_clearB3:
		if (ssd1306_CheckScreenReady(250)) {
			oledClearButton(buttons.button[B3].xCoord, buttons.button[B3].yCoord, BUTTON_SIZE, Black);
			demo.startup_state = startup_dwn_clearB7;
		}
		break;
	case startup_dwn_clearB7:
		if (ssd1306_CheckScreenReady(250)) {
			oledClearButton(buttons.button[B7].xCoord, buttons.button[B7].yCoord, BUTTON_SIZE, Black);
			demo.startup_state = startup_dwn_dwn;
		}
		break;
	case startup_dwn_dwn:
		if (ssd1306_CheckScreenReady(100)) {
			//draw down arrow
			SSD1306_DrawFilledRectangle(114, 30, 2, 12, White);
			SSD1306_DrawFilledTriangle(112, 42, 115, 49, 118, 42, White);
			ssd1306_DrawPixel(114, 45, White);		//random black pixel
			demo.startup_state = startup_hold_clear;
		}
		break;

		/*		Hold Gesture		*/
	case startup_hold_clear:
		if (ssd1306_CheckScreenReady(500)) {
			oledClearGesture();
			oledClearAllButtons();
			demo.startup_state = startup_hold_all;
		}
		break;
	case startup_hold_all:
		if (ssd1306_CheckScreenReady(100)) {
			oledDrawButton_8btn("1", buttons.button[B1].xCoord, buttons.button[B1].yCoord, Font_6x8, White, b_touch);
			oledDrawButton_8btn("2", buttons.button[B2].xCoord, buttons.button[B2].yCoord, Font_6x8, White, b_touch);
			oledDrawButton_8btn("3", buttons.button[B3].xCoord, buttons.button[B3].yCoord, Font_6x8, White, b_touch);
			oledDrawButton_8btn("4", buttons.button[B4].xCoord, buttons.button[B4].yCoord, Font_6x8, White, b_touch);
			oledDrawButton_8btn("5", buttons.button[B5].xCoord, buttons.button[B5].yCoord, Font_6x8, White, b_touch);
			oledDrawButton_8btn("6", buttons.button[B6].xCoord, buttons.button[B6].yCoord, Font_6x8, White, b_touch);
			oledDrawButton_8btn("7", buttons.button[B7].xCoord, buttons.button[B7].yCoord, Font_6x8, White, b_touch);
			oledDrawButton_8btn("8", buttons.button[B8].xCoord, buttons.button[B8].yCoord, Font_6x8, White, b_touch);
			demo.startup_state = startup_hold_hold;
		}
		break;
	case startup_hold_hold:
		if (ssd1306_CheckScreenReady(500)) {
			oledDisplayText("hold", 102, 30, Font_6x8, White);
			demo.startup_state = startup_hall_plus;
		}
		break;


		/*		Hall Demonstration		*/
	case startup_hall_plus:
		if (ssd1306_CheckScreenReady(500)) {
			oledClearAllButtons();
			oledClearGesture();
			oledDisplayText("Hall", 0, 2, Font_6x8, White);
			oledDisplayText("+", 0, Y_MIDDLE - 10, Font_6x8, White);
			//center line
			SSD1306_DrawLine(0, Y_MIDDLE, 19, Y_MIDDLE, White);
			count = 0;	//counter for hall startup routine
			demo.startup_state = startup_hall_plus_loop;
		}
		break;
	case startup_hall_plus_loop:
		if (ssd1306_CheckScreenReady(40)) {
			if (count<20) {
				SSD1306_DrawFilledRectangle(6, Y_MIDDLE - (count), 8, (count), White);
				count++;
			} else{
				//clear bar area
				//SSD1306_DrawFilledRectangle(0, 10, 19, 21, Black);
				ssd1306_Clear_region(0, 10, 19, 31, Black);
				oledDisplayText("-", 0, Y_MIDDLE + 5, Font_6x8, White);
				SSD1306_DrawLine(0, Y_MIDDLE, 19, Y_MIDDLE, White);
				demo.startup_state = startup_hall_minus_loop;
				count = 0;
			}
		}
		break;
	case startup_hall_minus_loop:
		if (ssd1306_CheckScreenReady(40)) {

			if (count<20) {
				SSD1306_DrawFilledRectangle(6, Y_MIDDLE, 8, count, White);
				count++;
			} else{
				demo.startup_state = startup_clearAll;
			}
		}
		break;

	case startup_clearAll:
		if (ssd1306_CheckScreenReady(500)) {
			//clear all
			oledClear();
			demo.startup_state = startup_end;
		}
		break;

	case startup_end:
		if (ssd1306_CheckScreenReady(0)) {
			fillRoundRect(X_MIDDLE - 15, 1, 15, 10, 2, White);
			oledDisplayText("NP", X_MIDDLE - 13, 2, Font_6x8, Black);
			oledDisplayText("429uA", X_MIDDLE + 2, 2, Font_6x8, White);

			oledDisplayText("Hall", 0, 2, Font_6x8, White);
			//center line
			SSD1306_DrawLine(0, Y_MIDDLE, 0 + 19, Y_MIDDLE, White);

			oledDisplayText("8btn", 100, 2, Font_6x8, White);

			/* Initialize zero states */
			mode.current.touch = false;
			mode.current._8btn = true;
			mode.current.abscap = false;
			mode.current.draw = false;

			demo.startup_state = startup_done;
			demo.run_state = demo_run_begin;
		}
		break;

	case startup_done:		// Total time: 13000 ms
		break;

	default:
		demo.startup_state = startup_begin;
		break;
	}

}

/**
 * @brief Run demo loop to update and display all segments of the demo
 *
 * @param None.
 *
 *	@note Call this function in run board select loop.
 *
 * @retval None
 */
void run_demo_8btn(void)
{
	#ifdef DEBUG_DEMO
	LL_GPIO_ResetOutputPin(DEBUG_PORT, DEBUG_PIN);
	#endif

	/* Return if I2C is busy. */
	if ((_iqs269Ptr8->openwindow)||(!_iqs269Ptr8->jobdone))
		return;

	switch (demo.run_state) {

	case demo_run_startup:
		/* Run startup routine. */
		run_demoStartupRoutine_8btn();
		break;
	case demo_run_begin:
		if (_iqs269Ptr8->updated) {
			demo.run_state = demo_run_gestures;
		}
		if (demo.update) {
			demo.update = false;
			ssd1306_CheckScreenReady(0);
		}

		break;

	case demo_run_gestures:
		if (mode.current._8btn) {
			run_gestures();
			demo.run_state = demo_run_clearGesture;
		}
		else if(mode.current.draw)
		{
			/* Skip run hall, run gestures, run buttons, run pm if draw mode is active. */
			demo.run_state = demo_run_coordinates;
		}
		else if(mode.current.abscap)
		{
			/* Skip run hall, run gestures and run coordinates if abs cap mode is active. */
			demo.run_state = demo_run_absCap;
		}
		break;

	case demo_run_clearGesture:
		if (HAL_CheckTick(timerGesture, 500, true) && gestures.clearGesture)
		{
			gestures.clearGesture = false;
			oledClearGesture();
			demo.update = true;

		}
		demo.run_state = demo_run_hall;
		break;

	case demo_run_hall:
		run_hall();
		demo.run_state = demo_run_coordinates;

		break;

	case demo_run_coordinates:
		run_coordinates();

		if(mode.current.draw)
		{
			/* Skip  run buttons and run pm if draw mode is active. */
			demo.run_state = demo_run_done;
		} else
		{
			demo.run_state = demo_run_buttons;
		}
		break;

	case demo_run_absCap:
		run_absCap();
		demo.run_state = demo_run_buttons;
		break;

	case demo_run_buttons:
		demo.run_state = demo_run_b1;
		break;

	case demo_run_b1:
		run_button(IQS269_CH1, IQS269_CH3, B1, "1");
		demo.run_state = demo_run_b2;
		break;

	case demo_run_b2:
		run_button(IQS269_CH1, IQS269_CH4, B2, "2");
		demo.run_state = demo_run_b3;
		break;

	case demo_run_b3:
		run_button(IQS269_CH1, IQS269_CH5, B3, "3");
		demo.run_state = demo_run_b4;
		break;

	case demo_run_b4:
		run_button(IQS269_CH1, IQS269_CH6, B4, "4");
		demo.run_state = demo_run_b5;
		break;

	case demo_run_b5:
		run_button(IQS269_CH2, IQS269_CH3, B5, "5");
		demo.run_state = demo_run_b6;
		break;

	case demo_run_b6:
		run_button(IQS269_CH2, IQS269_CH4, B6, "6");
		demo.run_state = demo_run_b7;
		break;

	case demo_run_b7:
		run_button(IQS269_CH2, IQS269_CH5, B7, "7");
		demo.run_state = demo_run_b8;
		break;

	case demo_run_b8:
		run_button(IQS269_CH2, IQS269_CH6, B8, "8");
		demo.run_state = demo_run_pm;
		break;

	case demo_run_pm:
		run_pm();
		demo.run_state = demo_run_done;
		break;

	case demo_run_done:
		_iqs269Ptr8->updated = false;
		demo.run_state = demo_run_begin;
		break;

	case demo_run_idle:
		// Do nothing
		break;

	default:
		break;
	}
	#ifdef DEBUG_DEMO
	LL_GPIO_SetOutputPin(DEBUG_PORT, DEBUG_PIN);
	#endif

}

/**
 * @brief Update the hall UI and update the screen if the delta and state changed
 *
 * @param None
 *
 * @retval None
 */
void run_hall(void)
{
	uint8_t new_state;
	int16_t new_delta;

	new_delta = (iqs269_readChannelDelta(IQS269_CH7));

	///////////////////////////////////////////////////////////////////////////
	/* Moving average begin. */
	if (!firstHallEvent)
	{
		/* Initialize filter arrays with the first hall event information. */
		hall.delta_filter[4] = new_delta;
		hall.delta_filter[3] = new_delta;
		hall.delta_filter[2] = new_delta;
		hall.delta_filter[1] = new_delta;
		hall.delta_filter[0] = new_delta;

		firstHallEvent = true;
	}
	else
	{
		/* Filter x coordinates. */
		hall.delta_filter[4] = hall.delta_filter[3];
		hall.delta_filter[3] = hall.delta_filter[2];
		hall.delta_filter[2] = hall.delta_filter[1];
		hall.delta_filter[1] = hall.delta_filter[0];
		hall.delta_filter[0] = new_delta;
	}

	new_delta = (hall.delta_filter[0] + hall.delta_filter[1] + hall.delta_filter[2] + hall.delta_filter[3] + hall.delta_filter[4])/5;
	/* Moving average end.*/
	///////////////////////////////////////////////////////////////////////////////

	if (iqs269_Channel_DeepTouchState(IQS269_CH7))
	{
		new_state = hall_deep;
	}
	else if (iqs269_Channel_TouchState(IQS269_CH7))
	{
		new_state = hall_touch;
	}
	else if (iqs269_Channel_ProxState(IQS269_CH7))
	{
		new_state = hall_prox;
	}
	else
	{
		new_state = hall_zero;
	}

	if ((hall.state == new_state) && ((hall.delta <= new_delta+0) && (hall.delta >= new_delta-0)))
	{
		return;
	}
	else
	{
		#ifdef DEBUG_HALL
		LL_GPIO_ResetOutputPin(DEBUG_PORT, DEBUG_PIN);
		#endif

		oledBar(0, new_delta, new_delta);

		#ifdef DEBUG_HALL
		LL_GPIO_SetOutputPin(DEBUG_PORT, DEBUG_PIN);
		#endif

		hall.state = new_state;
		hall.delta = new_delta;
		demo.update = true;
	}
}

/**
 * @brief Update the gestures UI and update the screen with the gesture.
 *
 * @param None
 *
 * @retval None
 */
void run_gestures(void)
{
	uint8_t new_state0;
	uint8_t new_state1;

	if (iqs269_GestureEvent()) {

		switch (iqs269_SliderEvent(IQS269_SL0)) {
		case FLICK_NEG_0:
			new_state0 = FLICK_NEG_0;
			oledClearGesture();
			// draw left arrow
			SSD1306_DrawFilledRectangle(111, 33, 12, 2, White);
			SSD1306_DrawFilledTriangle(111, 37, 111, 31, 104, 34, White);
			break;
		case FLICK_POS_0:
			new_state0 = FLICK_POS_0;
			oledClearGesture();
			//draw right arrow
			SSD1306_DrawFilledRectangle(103, 33, 12, 2, White);
			SSD1306_DrawFilledTriangle(116, 37, 116, 31, 123, 34, White);
			break;
		case HOLD_0:
			if (iqs269_Channel_TouchState(IQS269_CH0)) {
				new_state0 = HOLD_0;
				oledClearGesture();
				oledDisplayText("hold", 101, 30, Font_6x8, White);
				gestures.holdCleared = false;
			}
			break;
		case TAP_0:
			if (iqs269_DeepTouchEvent()) {
				new_state0 = TAP_0;
				oledClearGesture();
				oledDisplayText(" tap", 101, 30, Font_6x8, White);
			}
			break;
		case NO_GESTURE_0:
			new_state0 = NO_GESTURE_0;
			break;
		default:
			break;
		}

		switch (iqs269_SliderEvent(IQS269_SL1)) {
		case FLICK_NEG_1:
			new_state1 = FLICK_NEG_1;
			oledClearGesture();
			//draw up arrow
			SSD1306_DrawFilledRectangle(114, 37, 2, 12, White);
			SSD1306_DrawFilledTriangle(112, 37, 115, 30, 118, 37, White);
			ssd1306_DrawPixel(114, 34, White);		//random black pixel
			break;
		case FLICK_POS_1:
			new_state1 = FLICK_POS_1;
			oledClearGesture();
			//draw down arrow
			SSD1306_DrawFilledRectangle(114, 30, 2, 12, White);
			SSD1306_DrawFilledTriangle(112, 42, 115, 49, 118, 42, White);
			ssd1306_DrawPixel(114, 45, White);		//random black pixel
			break;
		case HOLD_1:
			if (iqs269_Channel_TouchState(IQS269_CH0)) {
				new_state1 = HOLD_1;
				oledClearGesture();
				oledDisplayText("hold", 101, 30, Font_6x8, White);
				gestures.holdCleared = false;
			}

			break;
		case TAP_1:
			if (iqs269_DeepTouchEvent()) {
				new_state1 = TAP_1;
				oledClearGesture();
				oledDisplayText(" tap", 101, 30, Font_6x8, White);
			}
			break;
		case NO_GESTURE_1:
			new_state1 = NO_GESTURE_1;
			break;
		default:
			break;
		}

		if ((new_state0 != HOLD_0) && (new_state1 != HOLD_1)) {
			gestures.clearGesture = true;
			timerGesture = HAL_GetTick();
			demo.update = true;
		}
	} else
	{
		if ((!iqs269_Channel_DeepTouchState(IQS269_CH0)) && (!gestures.holdCleared)) {
			oledClearGesture();
			gestures.holdCleared = true;
			demo.update = true;
		}
	}
}

/**
 * @brief Update the coordinates UI and update the screen if one of the coordinates changed.
 *
 * @param None
 *
 * @retval None
 */
void run_coordinates(void)
{
	uint8_t new_state;
	uint8_t new_xCoord;
	uint8_t new_yCoord;
	uint8_t new_draw_xCoord;
	uint8_t new_draw_yCoord;

	char dispBuff[64];
	if (iqs269_Channel_TouchState(IQS269_CH1)||iqs269_Channel_TouchState(IQS269_CH2))		// (iqs.touch.ch1 || iqs.touch.ch2) && (iqs.touch.ch3 || iqs.touch.ch4 || iqs.touch.ch5 || iqs.touch.ch6)
	{
		new_state = coordinate_active;
		new_xCoord = iqs269_SliderCoordinates(IQS269_SL0);
		new_yCoord = iqs269_SliderCoordinates(IQS269_SL1);
		/* Scale x and y coordinates to the size of the screen. */
		new_draw_xCoord = (new_xCoord*128)/255;
		new_draw_yCoord = (new_yCoord*64)/255;

		//		Smoothing for readability - Moving Average		//
		/* Coordinate limit conditioning. */
		/* X coordinate. */
		if (new_xCoord < X_LCL)
		{
			new_xCoord = X_LCL;
		}
		if (new_xCoord > X_UCL)
		{
			new_xCoord = X_UCL;
		}
		new_xCoord = ((new_xCoord - X_LCL)*X_MAX)/(X_UCL - X_LCL);

		/* Y coordinate. */
		if (new_yCoord < Y_LCL)
		{
			new_yCoord = Y_LCL;
		}
		if (new_yCoord > Y_UCL)
		{
			new_yCoord = Y_UCL;
		}
		new_yCoord = ((new_yCoord - Y_LCL)*Y_MAX)/(Y_UCL - Y_LCL);


		if (!firstTouch)
		{
			/* Initialize filter arrays with the first touch information. */
			coordinates.x_filter[4] = new_xCoord;
			coordinates.x_filter[3] = new_xCoord;
			coordinates.x_filter[2] = new_xCoord;
			coordinates.x_filter[1] = new_xCoord;
			coordinates.x_filter[0] = new_xCoord;

			coordinates.y_filter[4] = new_yCoord;
			coordinates.y_filter[3] = new_yCoord;
			coordinates.y_filter[2] = new_yCoord;
			coordinates.y_filter[1] = new_yCoord;
			coordinates.y_filter[0] = new_yCoord;

			firstTouch = true;
		}
		else
		{
			/* Filter x coordinates. */
			coordinates.x_filter[4] = coordinates.x_filter[3];
			coordinates.x_filter[3] = coordinates.x_filter[2];
			coordinates.x_filter[2] = coordinates.x_filter[1];
			coordinates.x_filter[1] = coordinates.x_filter[0];
			coordinates.x_filter[0] = new_xCoord;

			/* Filter y coordinates. */
			coordinates.y_filter[4] = coordinates.y_filter[3];
			coordinates.y_filter[3] = coordinates.y_filter[2];
			coordinates.y_filter[2] = coordinates.y_filter[1];
			coordinates.y_filter[1] = coordinates.y_filter[0];
			coordinates.y_filter[0] = new_yCoord;
		}

		new_xCoord = (coordinates.x_filter[0] + coordinates.x_filter[1] + coordinates.x_filter[2] + coordinates.x_filter[3] + coordinates.x_filter[4])/5;
		new_yCoord = (coordinates.y_filter[0] + coordinates.y_filter[1] + coordinates.y_filter[2] + coordinates.y_filter[3] + coordinates.y_filter[4])/5;
		/////////////////////////////////////////////////////////
	}
	else
	{
		new_state = coordinate_clear;
	}

	if((coordinates.state != new_state) && (new_state == coordinate_clear))
	{
		coordinates.state = new_state;
		if (!mode.current.draw) {
			oledClearCoordinate();
		}
		demo.update = true;

	}
	else if ((new_xCoord != coordinates.xCoord) || (new_yCoord != coordinates.yCoord))
	{
		coordinates.state = new_state;
		coordinates.xCoord = new_xCoord;
		coordinates.yCoord = new_yCoord;



		/* Draw mode draw function. */
		if(mode.current.draw)
		{
			if (!(new_draw_xCoord > 96) || !(new_draw_yCoord < 12))
			{
				if ((iqs269_Channel_TouchState(IQS269_CH3)) ||  (iqs269_Channel_TouchState(IQS269_CH4)) ||  (iqs269_Channel_TouchState(IQS269_CH5)) ||  (iqs269_Channel_TouchState(IQS269_CH6)))
				{
					ssd1306_DrawPixel(new_draw_xCoord, new_draw_yCoord, White);
//					/* For continuous lines use this. */
//					if (((coordinates.draw_xCoord+10) >= new_draw_xCoord) || ((coordinates.draw_xCoord-10) <= new_draw_xCoord))
//					{
//						SSD1306_DrawLine(coordinates.draw_xCoord, coordinates.draw_yCoord, new_draw_xCoord, new_draw_yCoord, White); //todo: fix random coords
//					}
				}
			}
		}
		else if (new_state == coordinate_active)
		{
			oledClearCoordinate();
			oledDisplayText("X:", 40, 56, Font_6x8, White);
			oledDisplayText(utoa(new_xCoord, dispBuff, 10), 52, 56, Font_6x8, White);
			oledDisplayText("Y:", 80, 56, Font_6x8, White);
			oledDisplayText(utoa(new_yCoord, dispBuff, 10), 92, 56, Font_6x8, White);
		}
		demo.update = true;

		coordinates.draw_xCoord = new_draw_xCoord;
		coordinates.draw_yCoord = new_draw_yCoord;
	}
}

/**
 * @brief Update the power modes UI and update the screen if the state changed.
 *
 * @param None
 *
 * @retval None
 */
void run_pm(void)
{
	uint8_t new_state;
	switch (iqs269_GetPowerMode())
	{
	case IQS269_POWER_MODE_NORMAL:
		new_state = pm_np;
		break;
	case IQS269_POWER_MODE_LOW:
		new_state = pm_lp;
		break;
	case IQS269_POWER_MODE_ULTRA_LOW:
		new_state = pm_ulp;
		break;
	default:
		break;
	}

	if (pm.state != new_state)
	{
		pm.state = new_state;
		demo.update = true;
		switch (new_state) {
		case pm_np:
			oledClearPM();
			fillRoundRect(X_MIDDLE - 15, 1, 15, 10, 2, White);
			oledDisplayText("NP", X_MIDDLE - 13, 2, Font_6x8, Black);
			oledDisplayText("429uA", X_MIDDLE + 2, 2, Font_6x8, White);
			break;
		case pm_lp:
			oledClearPM();
			fillRoundRect(X_MIDDLE - 15, 1, 15, 10, 2, White);
			oledDisplayText("LP", X_MIDDLE - 13, 2, Font_6x8, Black);
			oledDisplayText("45uA", X_MIDDLE + 7, 2, Font_6x8, White);
			break;
		case pm_ulp:
			oledClearPM();
			fillRoundRect(X_MIDDLE - 15, 1, 20, 10, 2, White);
			oledDisplayText("ULP", X_MIDDLE - 13, 2, Font_6x8, Black);
			oledDisplayText("13uA", X_MIDDLE + 7, 2, Font_6x8, White);
			break;
		default:
			break;
		}
	}
}

/**
 * @brief Update the button state and display the state if it changed
 *
 * @param uint8_t : \b ch_x -  Specifies the IQS channel on the x-axis of the 8btn board
 *
 * @param uint8_t : \b ch_y -  Specifies the IQS channel on the y-axis of the 8btn board
 *
 * @param uint8_t : \b button_tag -  Specifies the button number macro defined in demo.h
 *
 * @param char* : \b numberText -  Specifies the text to be displayed in the button block
 *
 * @note Example : run_button(IQS269_CH1, IQS269_CH3, B1, "1");
 *
 * @retval None
 */
void run_button(uint8_t ch_x, uint8_t ch_y, uint8_t button_tag, char* numberText)
{
	#ifdef DEBUG_BUTTON
	LL_GPIO_ResetOutputPin(DEBUG_PORT, DEBUG_PIN);
	#endif


	if (iqs269_Channel_DeepTouchState(ch_x) && iqs269_Channel_DeepTouchState(ch_y))
	{
		buttons.button[button_tag].new_state = b_deep;
	}
	else if (iqs269_Channel_TouchState(ch_x) && iqs269_Channel_TouchState(ch_y))
	{
		buttons.button[button_tag].new_state = b_touch;

	}
	else if (iqs269_Channel_ProxState(ch_x) && iqs269_Channel_ProxState(ch_y))
	{
		buttons.button[button_tag].new_state = b_prox;

	}
	else //None
	{
		buttons.button[button_tag].new_state = b_none;
	}

	if (buttons.button[button_tag].state != buttons.button[button_tag].new_state) {
			oledClearButton(buttons.button[button_tag].xCoord, buttons.button[button_tag].yCoord, BUTTON_SIZE, Black);
			oledDrawButton_8btn(numberText, buttons.button[button_tag].xCoord, buttons.button[button_tag].yCoord, Font_6x8, White, buttons.button[button_tag].new_state);

			demo.update = true;
			buttons.button[button_tag].state = buttons.button[button_tag].new_state;
	}

	#ifdef DEBUG_BUTTON
	LL_GPIO_SetOutputPin(DEBUG_PORT, DEBUG_PIN);
	#endif
}

/**
 * @brief Update the button state and display the state if it changed
 *
 * @param char* : \b numberText -  Specifies the text to be displayed in the button block.
 * @param uint8_t : \b xCoord -  Specifies the x coordinate of the larger round rectangle.
 * @param uint8_t : \b yCoord -  Specifies the y coordinate of the larger round rectangle.
 * @param FontDef : \b font -  Specifies the font size to write the number text with.
 * @param SSD1306_COLOR : \b color -  Specifies the color of the number text and rectangles.
 * @param Button_e : \b state - Specifies the current state of the specific button.
 *
 * @note Example : oledDrawButton(numberText, buttons.button[button_tag].xCoord, buttons.button[button_tag].yCoord, Font_6x8, White, buttons.button[button_tag].new_state);
 *
 * @retval None.
 */
void oledDrawButton_8btn(char* numberText, uint8_t xCoord, uint8_t yCoord, FontDef Font, SSD1306_COLOR color, Button_8btn_e state)
{
	switch (state) {
	case b_deep:
		oledDisplayText(numberText, xCoord+8, yCoord+6, Font, color);
		drawRoundRect(xCoord, yCoord, BUTTON_SIZE, BUTTON_SIZE, 5, color);
		drawRoundRect(xCoord+2, yCoord+2, BUTTON_SIZE - 4, BUTTON_SIZE - 4, 3, color);
		break;
	case b_touch:
		oledDisplayText(numberText, xCoord+8, yCoord+6, Font, color);
		drawRoundRect(xCoord, yCoord, BUTTON_SIZE, BUTTON_SIZE, 5, color);
		break;
	case b_prox:
		oledDisplayText(numberText, xCoord+8, yCoord+6, Font, color);
		break;
	case b_none:
		break;
	default:
		break;
	}

}

/**
 * @brief Clear the button area of the specified button.
 *
 * @param uint8_t : \b xCoord -  Specifies the x coordinate of the larger round rectangle.
 * @param uint8_t : \b yCoord -  Specifies the y coordinate of the larger round rectangle.
 * @param uint8_t : \b size -  Specifies the size of the button on the display.
 * @param SSD1306_COLOR : \b color -  Specifies the color to clear with.
 *
 * @note Example : oledClearButton(buttons.button[button_tag].xCoord, buttons.button[button_tag].yCoord, BUTTON_SIZE, Black);
 *
 * @retval None.
 */
void oledClearButton(uint8_t xCoord, uint8_t yCoord, uint8_t size, SSD1306_COLOR color)
{
	//SSD1306_DrawFilledRectangle(xCoord, yCoord, size-1, size-1, color);
	ssd1306_Clear_region(xCoord, yCoord, (xCoord+size), (yCoord+size), color);
}


/**
 * @brief Set the cursor and write text.
 *
 * @param char* : \b text - Specifies the text to be written.
 * @param uint8_t : \b xCoord -  Specifies the x coordinate of the cursor.
 * @param uint8_t : \b yCoord -  Specifies the y coordinate of the cursor.
 * @param FontDef : \b Font -  Specifies the size of the text.
 * @param SSD1306_COLOR : \b color -  Specifies the color of the text.
 *
 * @note Example : oledDisplayText("Hello World!", 15, 20, Font_6x8, White);
 * @note To display signed int oledDisplayText(itoa(counts, dispBuff1, 10), 0, 54, Font_6x8, White);
 * @note To display unsigned int use utoa, and for floats use ftoa.
 *
 * @retval None.
 */
void oledDisplayText(char* text, uint8_t xCoord, uint8_t yCoord, FontDef Font, SSD1306_COLOR color)
{
	ssd1306_SetCursor(xCoord, yCoord);
	ssd1306_WriteString(text, Font, color);
}

/**
 * @brief Clear the entire screen to Black.
 *
 * @param None
 *
 * @retval None
 */
void oledClear(void)
{
	ssd1306_Fill(Black); // Clear all
}

/**
 * @brief Clear the entire button area.
 *
 * @param None
 *
 * @retval None
 */
void oledClearAllButtons(void)
{
	//SSD1306_DrawFilledRectangle(20, 14, 4 * BUTTON_SIZE, 2 * BUTTON_SIZE, Black);
	ssd1306_Clear_region(20, 14, (20+(4 * BUTTON_SIZE)), (14+(2 * BUTTON_SIZE)), Black);
}

/*
 * @brief Clears the OLED Mode name display.
 *
 * @param None.
 *
 * @retval None.
 */
void oledClearModeName(void)
{
	//SSD1306_DrawFilledRectangle(100, 2, 28, 20, Black);
	ssd1306_Clear_region(100, 2, 128, 10, Black);
}

/* @brief Clears the OLED Func display.
 *
 * @param None.
 *
 * @retval None.
 */
void oledClearFunc(void)
{
	//SSD1306_DrawFilledRectangle(100, 2, 28, 20, Black);
	ssd1306_Clear_region(100, 2, 128, 10, Black);
}

/* @brief Clears the OLED PM display.
 *
 * @param None.
 *
 * @retval None.
 */
void oledClearPM(void)
{
	//SSD1306_DrawFilledRectangle(X_MIDDLE - 15, 0, 40, 12, Black);
	ssd1306_Clear_region(X_MIDDLE - 15, 0, X_MIDDLE + 25, 12, Black);
}

/* @brief Clears the OLED Gesture display.
 *
 * @param None.
 *
 * @retval None.
 */
void oledClearGesture(void)
{
	//SSD1306_DrawFilledRectangle(101, 30, 27, 20, Black);
	ssd1306_Clear_region(101, 30, 128, 50, Black);
}

/* @brief Clears the OLED AbsCh display.
 *
 * @param None.
 *
 * @retval None.
 */
void oledClearAbsCh(void)
{
	//SSD1306_DrawFilledRectangle(25, 54, 60, 10, Black);
//	ssd1306_Clear_region(25, 54, 85, 64, Black);
	ssd1306_Clear_region(20, 54, 80, 64, Black);
}

/* @brief Clears the OLED AbsCap display.
 *
 * @param None.
 *
 * @retval None.
 */
void oledClearAbsCap(void)
{
	//SSD1306_DrawFilledRectangle(85, 54, 53, 20, Black);
//	ssd1306_Clear_region(85, 54, 128, 64, Black);
	ssd1306_Clear_region(80, 54, 128, 64, Black);
}

/* @brief Clears the OLED Coordinate display.
 *
 * @param None.
 *
 * @retval None.
 */
void oledClearCoordinate(void)
{
	//SSD1306_DrawFilledRectangle(40, 56, 88, 20, Black);
	ssd1306_Clear_region(40, 56, 118, 64, Black);
}




/* @brief Displays the Delta parameter on the OLED display at x position.
 *
 * @param uint8_t : \b x - x coordinate of the center line.
 * @param int16_t : \b delta - Delta number to draw the bar with.
 * @param int16_t : \b displayDelta - Delta number to display below bar.
 *
 * @retval None.
 */
void oledBar(uint8_t x, int16_t delta, int16_t displayDelta)
{
	int16_t difference;
	char dispBuff1[64];

	if ((hall.prev_delta > 0) && (delta < 0)) {
		// clear the positive bar area
		//SSD1306_DrawFilledRectangle(x+6, Y_MIDDLE - 21, 8, 21, Black);
		ssd1306_Clear_region(x + 6, Y_MIDDLE - 21, x + 15, Y_MIDDLE, Black);
	} else if((hall.prev_delta < 0) && (delta > 0))
	{
		// clear the negative bar area
		//SSD1306_DrawFilledRectangle(x+6, Y_MIDDLE, 8, 21, Black);
		ssd1306_Clear_region(x + 6, Y_MIDDLE, x + 15, Y_MIDDLE + 21, Black);
	} else if ((delta == 0) || (pm.state == pm_ulp))
	{
		//SSD1306_DrawFilledRectangle(x+6, Y_MIDDLE - 3, 8, 6, Black);
		ssd1306_Clear_region(x + 6, Y_MIDDLE - 3, x + 15, Y_MIDDLE + 3, Black);
	}

	//clear delta
	//SSD1306_DrawFilledRectangle(x, 54, 23, 64, Black);
	ssd1306_Clear_region(x, 54, x + 24, 64, Black);

	// Display the delta value
	oledDisplayText(itoa((abs(displayDelta)), dispBuff1, 10), x, 54, Font_6x8, White);

	if (delta / 3 > 21) //Just to control the max
	{
		delta = 21 * 3;
	}
	else if (delta / 3 < -21)
	{
		delta = -21 * 3;
	}

	if (delta > 0)
	{
		if ((hall.prev_delta > delta) ) {	//&& ((delta/3) >= 1)
			//only clear the difference
			difference = hall.prev_delta - delta;
			//SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE - (hall.prev_delta / 3), 8, (difference / 3), Black);
			ssd1306_Clear_region(x + 6, Y_MIDDLE - (hall.prev_delta / 3), x + 15, (Y_MIDDLE - (hall.prev_delta / 3)) + (difference / 3) + 1, Black);

		} else // delta greater than prev delta
		{
			//only draw the difference
			difference = delta - hall.prev_delta;

			/* The bar will sometimes miss one row of pixels. Check this condition to fix this bug. */
			if (delta > 5) {
				SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE - (delta / 3), 8, (difference / 3)+1, White);
			} else
			{
				SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE - (delta / 3), 8, (difference / 3), White);
			}
		}

		if ((delta > 10)){
			oledDisplayText("+", x, Y_MIDDLE - 10, Font_6x8, White);
		} else
		{
			//Clear the plus sign
			//SSD1306_DrawFilledRectangle(x, Y_MIDDLE - 10, 4, 6, Black);
			ssd1306_Clear_region(x, Y_MIDDLE - 10, x + 6, Y_MIDDLE - 4, Black);
		}
	}
	else //delta smaller than 0
	{
		if ((hall.prev_delta < delta)) {
			difference = hall.prev_delta - delta;
			//SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE + (abs(delta) / 3), 8, (abs(difference / 3))+1, Black);
			ssd1306_Clear_region(x + 6, Y_MIDDLE + (abs(delta) / 3), x + 15, (Y_MIDDLE + (abs(delta) / 3)) + ((abs(difference / 3))+2), Black);
		} else
		{
			difference = delta - hall.prev_delta;
			SSD1306_DrawFilledRectangle(x + 6, Y_MIDDLE + (abs(hall.prev_delta / 3)), 8, (abs(difference) / 3), White);
		}

		if ((delta < -10)){
			oledDisplayText("-", x, Y_MIDDLE + 5, Font_6x8, White);
		} else
		{
			//Clear the minus sign
			//SSD1306_DrawFilledRectangle(x, Y_MIDDLE + 5, 4, 6, Black);
			ssd1306_Clear_region(x, Y_MIDDLE + 5, x + 6, Y_MIDDLE + 11, Black);
		}
	}
	//center line
	SSD1306_DrawLine(x, Y_MIDDLE, x + 19, Y_MIDDLE, White);
	hall.prev_delta = delta;
}



/* @brief Update the Abs Cap measurement and display
 *
 * @param None.
 *
 * @retval None.
 */
void run_absCap(void)
{
	char AbsCapDisp[64];
	uint32_t new_cap0 = iqs269_getAbsCapMeasurement(IQS269_C0);
	if (abscap.cap0 != new_cap0) {
		oledClearAbsCap();
		//	oledDisplayText(utoa(new_cap0, AbsCapDisp, 10), 85, 54, Font_6x8, White);

		// 2 digits after the decimal point
		oledDisplayText(ftoa((double)(new_cap0/100.0), AbsCapDisp, 2), 80, 54, Font_6x8, White);
		oledDisplayText("pF", 116, 54, Font_6x8, White);

		abscap.cap0 = new_cap0;
		demo.update = true;
	}
}


/* @brief Check what the function of the button is based on the board state.
 *
 * @param None.
 *
 * @retval None.
 */
void doBtnModeFunction_8btn(void)
{
	/* Skip the startup routine if it is currently running. */
	if (demo.startup_state < startup_end)
	{
		demo.startup_state = startup_clearAll;
	} else {
		if (mode.current._8btn) {

			mode.current._8btn = false;
			mode.current.abscap = false;
			mode.current.draw = true;

			// Clear all
			oledClear();
			// Display ModeName on OLED.
			oledDisplayText("DRAW", 100, 2, Font_6x8, White);

			demo.update = true;

		}
		else if (mode.current.draw)
		{

			oledClear();

			fillRoundRect(X_MIDDLE - 15, 1, 15, 10, 2, White);
			oledDisplayText("NP", X_MIDDLE - 13, 2, Font_6x8, Black);
			oledDisplayText("429uA", X_MIDDLE + 2, 2, Font_6x8, White);

			//Activate the Absolute Cap mode
			mode.current._8btn = false;
			mode.current.abscap = true;
			mode.current.draw = false;
			//oledClearGesture();

			// Display ModeName on OLED.
			//oledClearModeName();
			oledDisplayText("ABS", 100, 2, Font_6x8, White);

			//clear hall center line
			//SSD1306_DrawFilledRectangle(0, Y_MIDDLE - 3, 19, 6, Black);
			//ssd1306_Clear_region(0, Y_MIDDLE - 3, 19, Y_MIDDLE + 3, Black);
			//clear delta
			//SSD1306_DrawFilledRectangle(0, 54, 23, 64, Black);
			//ssd1306_Clear_region(0, 54, 23, 64, Black);
			//clear Hall
			//SSD1306_DrawFilledRectangle(0, 2, 24, 8, Black);
			//ssd1306_Clear_region(0, 2, 24, 10, Black);

			iqs269_deQueueValueUpdates();

			iqs269_disable_AutoPower_switch(I2C_RESTART);
			//Set to 4MHz FOSC; Xfer = 125kHz
			iqs269_setFOSC(IQS269_SYSTEM_CLOCK_4MHZ, I2C_RESTART);
			// Autone after making settings.
			iqs269_atiChannels(0xFF, I2C_STOP);

			//Enable the UI
			iqs269_enableAbsCapUI(I2C_RESTART);
			iqs269_abscap_MeasCap_Selection(IQS269_C0, IQS269_0pF5, I2C_RESTART);

			iqs269_setAbsCapCH(IQS269_CH0, I2C_STOP);
			oledClearAbsCh();

			abs_channel = 0;
			oledDisplayText("CH0(====):", 20, 54, Font_6x8, White);

//			if (boardSelect.bs._0) {
//				oledDisplayText("All CX:", 25, 54, Font_6x8, White);
//			} else {
//				oledDisplayText("CH0(====):", 25, 54, Font_6x8, White);
//			}

//			iqs269_QueueValueUpdates();
			iqs269_QueueABSCapValueUpdates();

			demo.run_state = demo_run_absCap;
			demo.update = true;

		} else if (mode.current.abscap)
		{

			//Deactivate the Absolute Cap mode
			mode.current._8btn = true;
			mode.current.abscap = false;
			mode.current.draw = false;

			iqs269_deQueueValueUpdates();

			iqs269_enable_AutoPower_switch(I2C_RESTART);
			//Disable the UI
			iqs269_disableAbsCapUI(I2C_RESTART);

			//Set back to 16MHz FOSC
			iqs269_setFOSC(IQS269_SYSTEM_CLOCK_16MHZ, I2C_RESTART);
			// Auto tune after making settings.
			iqs269_atiChannels(0xFF, I2C_STOP);

			oledClearAbsCap();
			oledClearAbsCh();
			// Display ModeName on OLED.
			oledClearModeName();
			oledDisplayText("8btn", 100, 2, Font_6x8, White);
			oledDisplayText("Hall", 0, 2, Font_6x8, White);
			//center line
			SSD1306_DrawLine(0, Y_MIDDLE, 0 + 19, Y_MIDDLE, White);
			demo.update = true;

			iqs269_QueueValueUpdates();
		}
	}
}

/* @brief Check what the function of the button is based on the board state.
 *
 * @param None.
 *
 * @retval None.
 */
void doBtn1Function_8btn(void)
{
	demo.update = true;
	if (mode.current.draw) {
		oledClear();
		oledDisplayText("DRAW", 100, 2, Font_6x8, White);
	}
	else if (mode.current.abscap)
	{
		abs_channel++;

		if (abs_channel == 7)
		{
			abs_channel = 0;
		}

		switch (abs_channel)
		{
		case 0:
			iqs269_deQueueValueUpdates();
			iqs269_setAbsCapCH(IQS269_CH0, I2C_STOP);
			iqs269_QueueABSCapValueUpdates();
			oledClearAbsCh();
			oledDisplayText("CH0(====):", 20, 54, Font_6x8, White);
//			if (boardSelect.bs._0) {
//				oledDisplayText("All CX:", 25, 54, Font_6x8, White);
//			} else {
//				oledDisplayText("CH0(====):", 25, 54, Font_6x8, White);
//			}
			break;
		case 1:
			iqs269_deQueueValueUpdates();
			iqs269_setAbsCapCH(IQS269_CH1, I2C_STOP);
			iqs269_QueueABSCapValueUpdates();
			oledClearAbsCh();
			oledDisplayText("CH1(----):", 20, 54, Font_6x8, White);
//			if (boardSelect.bs._0) {
//				oledDisplayText("CX1 3 4 5:", 25, 54, Font_6x8, White);
//			} else {
//				oledDisplayText("CH1(----):", 25, 54, Font_6x8, White);
//			}
			break;
		case 2:
			iqs269_deQueueValueUpdates();
			iqs269_setAbsCapCH(IQS269_CH2, I2C_STOP);
			iqs269_QueueABSCapValueUpdates();
			oledClearAbsCh();
			oledDisplayText("CH2(____):", 20, 54, Font_6x8, White);
//			if (boardSelect.bs._0) {
//				oledDisplayText("CX0 2 6 7:", 25, 54, Font_6x8, White);
//			} else {
//				oledDisplayText("CH2(____):", 25, 54, Font_6x8, White);
//			}
			break;
		case 3:
			iqs269_deQueueValueUpdates();
			iqs269_setAbsCapCH(IQS269_CH3, I2C_STOP);
			iqs269_QueueABSCapValueUpdates();
			oledClearAbsCh();
			oledDisplayText("CH3(1&5):", 20, 54, Font_6x8, White);
//			if (boardSelect.bs._0) {
//				oledDisplayText("CX4 & 7:", 25, 54, Font_6x8, White);
//			} else {
//				oledDisplayText("CH3(1&5):", 25, 54, Font_6x8, White);
//			}
			break;
		case 4:
			iqs269_deQueueValueUpdates();
			iqs269_setAbsCapCH(IQS269_CH4, I2C_STOP);
			iqs269_QueueABSCapValueUpdates();
			oledClearAbsCh();
			oledDisplayText("CH4(2&6):", 20, 54, Font_6x8, White);
//			if (boardSelect.bs._0) {
//				oledDisplayText("CX1 & 6:", 25, 54, Font_6x8, White);
//			} else {
//				oledDisplayText("CH4(2&6):", 25, 54, Font_6x8, White);
//			}
			break;
		case 5:
			iqs269_deQueueValueUpdates();
			iqs269_setAbsCapCH(IQS269_CH5, I2C_STOP);
			iqs269_QueueABSCapValueUpdates();
			oledClearAbsCh();
			oledDisplayText("CH5(3&7):", 20, 54, Font_6x8, White);
//			if (boardSelect.bs._0) {
//				oledDisplayText("CX0 & 5:", 25, 54, Font_6x8, White);
//			} else {
//				oledDisplayText("CH5(3&7):", 25, 54, Font_6x8, White);
//			}
			break;
		case 6:
			iqs269_deQueueValueUpdates();
			iqs269_setAbsCapCH(IQS269_CH6, I2C_STOP);
			iqs269_QueueABSCapValueUpdates();
			oledClearAbsCh();
			oledDisplayText("CH6(4&8):", 20, 54, Font_6x8, White);
//			if (boardSelect.bs._0) {
//				oledDisplayText("CX2 & 3:", 25, 54, Font_6x8, White);
//			} else {
//				oledDisplayText("CH6(4&8):", 25, 54, Font_6x8, White);
//			}
			break;
		default:
			break;
		}
	}
}

/**
 * @brief  		Initialize the pointer to the iqs269 instance
 *
 * @param  	iqs269_s* : \b iqs269 - Pointer to iqs269 instance
 *
 * @return 		None
 */
void iqs269_pointer_init_8btn(iqs269_s *iqs269)
{
	_iqs269Ptr8 = iqs269;
}

