/*** Includes ***/
#include <demo_slider.h>
#include "main.h"
#include "draw.h"
#include "spi_dma.h"
#include "AZQ_util.h"
#include "iqs269.h"
#include "IQS269A_settings_slider.h"

demo_slider_s demo;
gestures_slider_s gestures;
coordinates_slider_s coordinates;
volume_s volume;

iqs269_s *_iqs269Ptr;

uint8_t count;
uint32_t timerBTN_Mode;
uint32_t timerBTN1;
uint32_t timerGesture;
//uint32_t modeTimer;
uint32_t holdtimer;
uint32_t volbartimer;
bool holdflagpos = false;
bool holdflagneg = false;
bool holdflag = false;
uint8_t touchx[2];
uint32_t touchtimer;
uint8_t touch_index =0;
uint32_t relative_coord[2];
uint32_t texttimer;
bool writeHOLD = false;
bool touchflag = false;
IQS269_gesture_e tempGesture;

uint8_t modeIndex = 0;
uint8_t count_startup = 0;

bool firstTouch_slider = false;


/**
 @brief Configure settings for IQS269 demo (B&O Slider demo)
 *
 * @param None
 *
 * @retval None
 */
void Configure_demo_slider(void){

	/* Configure DEBUG Pin */
	#ifdef DEBUG_IO
	gpio_init(DEBUG_PORT, DEBUG_PIN, LL_GPIO_MODE_OUTPUT, FUNCTION_NOT_USED, FUNCTION_NOT_USED, LL_GPIO_PULL_UP, LL_GPIO_SPEED_FREQ_VERY_HIGH);
	LL_GPIO_SetOutputPin(DEBUG_PORT, DEBUG_PIN);
	#endif


	init_volume_startpos();
}

/**
 @brief Reset the states of the 8btn demo state machines
 *
 * @param None
 *
 * @retval None
 */
void reset_demo_slider(void)
{
	demo.startup_slider_state = startup_slider_begin;
	demo.run_slider_state = demo_slider_run_startup;
	volume.prev_delta = 0;
	volume.prev_vol = 0;
	init_volume_startpos();
	modeIndex = 0;
	init_settings_slider();
	_iqs269Ptr->state = IQS269_STATE_NONE;
	_iqs269Ptr->init_state = IQS269_INIT_INTERFACE;

}

void init_settings_slider(void)
{

		// Addresses 0x80 Byte0 to 0x85 Byte1.

		_iqs269Ptr->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_pmu_general_settings 	= PMU_GENERAL_SETTINGS;
		_iqs269Ptr->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_i2c_general_settings 	= I2C_GENERAL_SETTINGS;
		_iqs269Ptr->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_sys_chb_active 			= SYS_CHB_ACTIVE;
		_iqs269Ptr->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_acf_lta_filter_settings = ACF_LTA_FILTER_SETTINGS;
		_iqs269Ptr->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_lta_chb_reseed_enabled 	= LTA_CHB_RESEED_ENABLED;
		_iqs269Ptr->IQSMemoryMap.iqs269_pow_sys_settings.iqs269_uis_global_events_mask 	= UIS_GLOBAL_EVENTS_MASK;
		_iqs269Ptr->IQSMemoryMap.iqs269_rep_timing.iqs269_pmu_report_rate_np 			= PMU_REPORT_RATE_NP;
		_iqs269Ptr->IQSMemoryMap.iqs269_rep_timing.iqs269_pmu_report_rate_lp 			= PMU_REPORT_RATE_LP;
		_iqs269Ptr->IQSMemoryMap.iqs269_rep_timing.iqs269_pmu_report_rate_ulp			= PMU_REPORT_RATE_ULP;
		_iqs269Ptr->IQSMemoryMap.iqs269_rep_timing.iqs269_pmu_mode_timout				= PMU_MODE_TIMOUT;
		_iqs269Ptr->IQSMemoryMap.iqs269_rep_timing.iqs269_i2c_window_timeout 			= I2C_WINDOW_TIMEOUT;
		_iqs269Ptr->IQSMemoryMap.iqs269_rep_timing.iqs269_lta_halt_timeout 				= LTA_HALT_TIMEOUT;
		_iqs269Ptr->IQSMemoryMap.iqs269_global_settings.iqs269_general_settings0		= PXS_GENERAL_SETTINGS0;
		_iqs269Ptr->IQSMemoryMap.iqs269_global_settings.iqs269_general_settings1		= PXS_GENERAL_SETTINGS1;
		_iqs269Ptr->IQSMemoryMap.iqs269_global_settings.iqs269_abs_cap_settings			= UIS_ABSOLUTE_CAPACITANCE;
		_iqs269Ptr->IQSMemoryMap.iqs269_global_settings.iqs269_ref_chan_gensetting		= UIS_DCF_GENERAL_SETTINGS;
		_iqs269Ptr->IQSMemoryMap.iqs269_global_settings.iqs269_ev_block					= GEM_CHB_BLOCK_NFOLLOW;
		_iqs269Ptr->IQSMemoryMap.iqs269_global_settings.iqs269_gen_res7					= MOV_CHB_MOVEMENT_CHANNEL;
		_iqs269Ptr->IQSMemoryMap.iqs269_global_settings.iqs269_chan_sel_slid0			= UIS_CHB_SLIDER0;
		_iqs269Ptr->IQSMemoryMap.iqs269_global_settings.iqs269_chan_sel_slid1			= UIS_CHB_SLIDER1;
		_iqs269Ptr->IQSMemoryMap.iqs269_global_settings.iqs269_tap_timout_slid			= UIS_GESTURE_TAP_TIMEOUT;
		_iqs269Ptr->IQSMemoryMap.iqs269_global_settings.iqs269_swipe_timout_slid		= UIS_GESTURE_SWIPE_TIMEOUT;
		_iqs269Ptr->IQSMemoryMap.iqs269_global_settings.iqs269_swipe_thres_slid			= UIS_GESTURE_THRESHOLD;
		_iqs269Ptr->IQSMemoryMap.iqs269_global_settings.iqs269_chb_reseed_en			= LTA_CHB_RESEED;

		/* Channel 0 Settings - Read/Write */
		_iqs269Ptr->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_crxsel_ch0 				=  PXS_CRXSEL_CH0;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_ctxsel_ch0 				=  PXS_CTXSEL_CH0;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_proxctrl_ch0 			=  PXS_PROXCTRL_CH0;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_proxcfg0_ch0 			=  PXS_PROXCFG0_CH0 ;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_proxcfg1_testreg0_ch0	=  PXS_PROXCFG1_TESTREG0_CH0;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch0_settings.iqs269_ati_base_and_target_ch0		=  ATI_BASE_AND_TARGET_CH0;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch0_settings.iqs269_ati_mirror_ch0 				=  ATI_MIRROR_CH0;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch0_settings.iqs269_ati_pcc_ch0 				=  ATI_PCC_CH0;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_prox_threshold_ch0 		=  PXS_PROX_THRESHOLD_CH0;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_touch_threshold_ch0	 	=  PXS_TOUCH_THRESHOLD_CH0;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_deep_threshold_ch0 		=  PXS_DEEP_THRESHOLD_CH0;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch0_settings.iqs269_pxs_hysteresis_ch0 			=  PXS_HYSTERESIS_CH0;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch0_settings.iqs269_dcf_chb_association_ch0 	=  DCF_CHB_ASSOCIATION_CH0;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch0_settings.iqs269_dcf_weight_ch0 				=  DCF_WEIGHT_CH0;

		/* Channel 1 Settings - Read/Write */
		_iqs269Ptr->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_crxsel_ch1 				=  PXS_CRXSEL_CH1;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_ctxsel_ch1 				=  PXS_CTXSEL_CH1;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_proxctrl_ch1 			=  PXS_PROXCTRL_CH1;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_proxcfg0_ch1 			=  PXS_PROXCFG0_CH1;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_proxcfg1_testreg0_ch1	=  PXS_PROXCFG1_TESTREG0_CH1;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch1_settings.iqs269_ati_base_and_target_ch1		=  ATI_BASE_AND_TARGET_CH1;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch1_settings.iqs269_ati_mirror_ch1 				=  ATI_MIRROR_CH1;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch1_settings.iqs269_ati_pcc_ch1 				=  ATI_PCC_CH1;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_prox_threshold_ch1 		=  PXS_PROX_THRESHOLD_CH1;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_touch_threshold_ch1 	=  PXS_TOUCH_THRESHOLD_CH1;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_deep_threshold_ch1 		=  PXS_DEEP_THRESHOLD_CH1;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch1_settings.iqs269_pxs_hysteresis_ch1 			=  PXS_HYSTERESIS_CH1;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch1_settings.iqs269_dcf_chb_association_ch1 	=  DCF_CHB_ASSOCIATION_CH1;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch1_settings.iqs269_dcf_weight_ch1 				=  DCF_WEIGHT_CH1;

		/* Channel 2 Settings - Read/Write */
		_iqs269Ptr->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_crxsel_ch2 				=  PXS_CRXSEL_CH2;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_ctxsel_ch2 				=  PXS_CTXSEL_CH2;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_proxctrl_ch2 			=  PXS_PROXCTRL_CH2;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_proxcfg0_ch2 			=  PXS_PROXCFG0_CH2;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_proxcfg1_testreg0_ch2	=  PXS_PROXCFG1_TESTREG0_CH2;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch2_settings.iqs269_ati_base_and_target_ch2		=  ATI_BASE_AND_TARGET_CH2;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch2_settings.iqs269_ati_mirror_ch2 				=  ATI_MIRROR_CH2;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch2_settings.iqs269_ati_pcc_ch2 				=  ATI_PCC_CH2;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_prox_threshold_ch2 		=  PXS_PROX_THRESHOLD_CH2;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_touch_threshold_ch2 	=  PXS_TOUCH_THRESHOLD_CH2;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_deep_threshold_ch2		=  PXS_DEEP_THRESHOLD_CH2;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch2_settings.iqs269_pxs_hysteresis_ch2 			=  PXS_HYSTERESIS_CH2;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch2_settings.iqs269_dcf_chb_association_ch2 	=  DCF_CHB_ASSOCIATION_CH2;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch2_settings.iqs269_dcf_weight_ch2 				=  DCF_WEIGHT_CH2;

		/* Channel 3 Settings - Read/Write */
		_iqs269Ptr->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_crxsel_ch3 				=  PXS_CRXSEL_CH3;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_ctxsel_ch3 				=  PXS_CTXSEL_CH3;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_proxctrl_ch3 			=  PXS_PROXCTRL_CH3;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_proxcfg0_ch3 			=  PXS_PROXCFG0_CH3;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_proxcfg1_testreg0_ch3	=  PXS_PROXCFG1_TESTREG0_CH3;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch3_settings.iqs269_ati_base_and_target_ch3		=  ATI_BASE_AND_TARGET_CH3;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch3_settings.iqs269_ati_mirror_ch3 				=  ATI_MIRROR_CH3;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch3_settings.iqs269_ati_pcc_ch3 				=  ATI_PCC_CH3;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_prox_threshold_ch3 		=  PXS_PROX_THRESHOLD_CH3;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_touch_threshold_ch3 	=  PXS_TOUCH_THRESHOLD_CH3;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_deep_threshold_ch3		=  PXS_DEEP_THRESHOLD_CH3;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch3_settings.iqs269_pxs_hysteresis_ch3 			=  PXS_HYSTERESIS_CH3;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch3_settings.iqs269_dcf_chb_association_ch3 	=  DCF_CHB_ASSOCIATION_CH3;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch3_settings.iqs269_dcf_weight_ch3 				=  DCF_WEIGHT_CH3;

		/* Channel 4 Settings - Read/Write */
		_iqs269Ptr->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_crxsel_ch4 				=  PXS_CRXSEL_CH4;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_ctxsel_ch4 				=  PXS_CTXSEL_CH4;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_proxctrl_ch4 			=  PXS_PROXCTRL_CH4;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_proxcfg0_ch4 			=  PXS_PROXCFG0_CH4;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_proxcfg1_testreg0_ch4	=  PXS_PROXCFG1_TESTREG0_CH4;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch4_settings.iqs269_ati_base_and_target_ch4		=  ATI_BASE_AND_TARGET_CH4;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch4_settings.iqs269_ati_mirror_ch4 				=  ATI_MIRROR_CH4;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch4_settings.iqs269_ati_pcc_ch4 				=  ATI_PCC_CH4;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_prox_threshold_ch4 		=  PXS_PROX_THRESHOLD_CH4;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_touch_threshold_ch4 	=  PXS_TOUCH_THRESHOLD_CH4;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_deep_threshold_ch4		=  PXS_DEEP_THRESHOLD_CH4;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch4_settings.iqs269_pxs_hysteresis_ch4 			=  PXS_HYSTERESIS_CH4;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch4_settings.iqs269_dcf_chb_association_ch4 	=  DCF_CHB_ASSOCIATION_CH4;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch4_settings.iqs269_dcf_weight_ch4 				=  DCF_WEIGHT_CH4;

		/* Channel 5 Settings - Read/Write */
		_iqs269Ptr->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_crxsel_ch5 				=  PXS_CRXSEL_CH5;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_ctxsel_ch5 				=  PXS_CTXSEL_CH5;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_proxctrl_ch5 			=  PXS_PROXCTRL_CH5;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_proxcfg0_ch5 			=  PXS_PROXCFG0_CH5;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_proxcfg1_testreg0_ch5	=  PXS_PROXCFG1_TESTREG0_CH5;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch5_settings.iqs269_ati_base_and_target_ch5		=  ATI_BASE_AND_TARGET_CH5;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch5_settings.iqs269_ati_mirror_ch5 				=  ATI_MIRROR_CH5;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch5_settings.iqs269_ati_pcc_ch5 				=  ATI_PCC_CH5;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_prox_threshold_ch5 		=  PXS_PROX_THRESHOLD_CH5;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_touch_threshold_ch5 	=  PXS_TOUCH_THRESHOLD_CH5;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_deep_threshold_ch5		=  PXS_DEEP_THRESHOLD_CH5;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch5_settings.iqs269_pxs_hysteresis_ch5 			=  PXS_HYSTERESIS_CH5;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch5_settings.iqs269_dcf_chb_association_ch5 	=  DCF_CHB_ASSOCIATION_CH5;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch5_settings.iqs269_dcf_weight_ch5 				=  DCF_WEIGHT_CH5;

		/* Channel 6 Settings - Read/Write */
		_iqs269Ptr->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_crxsel_ch6 				=  PXS_CRXSEL_CH6;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_ctxsel_ch6 				=  PXS_CTXSEL_CH6;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_proxctrl_ch6 			=  PXS_PROXCTRL_CH6;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_proxcfg0_ch6 			=  PXS_PROXCFG0_CH6;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_proxcfg1_testreg0_ch6	=  PXS_PROXCFG1_TESTREG0_CH6;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch6_settings.iqs269_ati_base_and_target_ch6		=  ATI_BASE_AND_TARGET_CH6;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch6_settings.iqs269_ati_mirror_ch6 				=  ATI_MIRROR_CH6;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch6_settings.iqs269_ati_pcc_ch6 				=  ATI_PCC_CH6;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_prox_threshold_ch6 		=  PXS_PROX_THRESHOLD_CH6;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_touch_threshold_ch6 	=  PXS_TOUCH_THRESHOLD_CH6;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_deep_threshold_ch6		=  PXS_DEEP_THRESHOLD_CH6;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch6_settings.iqs269_pxs_hysteresis_ch6 			=  PXS_HYSTERESIS_CH6;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch6_settings.iqs269_dcf_chb_association_ch6 	=  DCF_CHB_ASSOCIATION_CH6;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch6_settings.iqs269_dcf_weight_ch6 				=  DCF_WEIGHT_CH6;

		/* Channel 7 Settings - Read/Write */
		_iqs269Ptr->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_crxsel_ch7 				=  PXS_CRXSEL_CH7;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_ctxsel_ch7 				=  PXS_CTXSEL_CH7;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_proxctrl_ch7 			=  PXS_PROXCTRL_CH7;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_proxcfg0_ch7 			=  PXS_PROXCFG0_CH7;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_proxcfg1_testreg0_ch7	=  PXS_PROXCFG1_TESTREG0_CH7;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch7_settings.iqs269_ati_base_and_target_ch7		=  ATI_BASE_AND_TARGET_CH7;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch7_settings.iqs269_ati_mirror_ch7 				=  ATI_MIRROR_CH7;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch7_settings.iqs269_ati_pcc_ch7 				=  ATI_PCC_CH7;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_prox_threshold_ch7 		=  PXS_PROX_THRESHOLD_CH7;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_touch_threshold_ch7 	=  PXS_TOUCH_THRESHOLD_CH7;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_deep_threshold_ch7		=  PXS_DEEP_THRESHOLD_CH7;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch7_settings.iqs269_pxs_hysteresis_ch7 			=  PXS_HYSTERESIS_CH7;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch7_settings.iqs269_dcf_chb_association_ch7 	=  DCF_CHB_ASSOCIATION_CH7;
		_iqs269Ptr->IQSMemoryMap.iqs269_ch7_settings.iqs269_dcf_weight_ch7 				=  DCF_WEIGHT_CH7;
}

/**
 @brief Run the startup routine.
 *
 * @param None
 *
 * @return None
 */
void run_demoStartupRoutine_slider(void){
	char dispBuff1[64];
	switch (demo.startup_slider_state) {
	case startup_slider_begin:
		if (ssd1306_CheckScreenReady(0)) {
			oledClear_slider();
			/* Display the Azoteq logo. */
			ssd1306_LoadLogo();
			count_startup = 0;
			demo.startup_slider_state = startup_slider_mode1_1;
		}
		break;

	case startup_slider_mode1_1:
		if (ssd1306_CheckScreenReady(1000)) {
			oledClear_slider();

			/* Display UI. */
			oledDisplayText_slider("Volume: ", 0, 0, Font_11x18, White);
			//base line of volume bar
			SSD1306_DrawLine(0, Y_MIDDLE-9, 0, Y_MIDDLE+9, White);

			oledDisplayText_slider("MODE 1", 50, 44, Font_6x8, White);
			oledDisplayText_slider("SWIPE", 50, 55, Font_6x8, White);
			demo.startup_slider_state = startup_slider_mode1_2;
		}
		break;

	case startup_slider_mode1_2:
		if (ssd1306_CheckScreenReady(300)) {
			if (count_startup<=6) {
				if ((count_startup%2) == 0) {

					if (count_startup != 0) {
						/* Draw arrow. */
						SSD1306_DrawFilledRectangle(103, 33, 12, 2, White);
						SSD1306_DrawFilledTriangle(116, 37, 116, 31, 123, 34, White);
					}

					SSD1306_DrawFilledRectangle(0, Y_MIDDLE-4, (26*(count_startup/2)/3), 8, White);
					oledDisplayText_slider(utoa((count_startup/2)*10, dispBuff1, 10), 80, 0, Font_11x18, White);
				}
				else
				{
					oledClearGesture_slider();
				}


				count_startup += 1;
			} else{
				/* Clear volume bar area. */
				ssd1306_Clear_region(1, Y_MIDDLE-4, 88, Y_MIDDLE+5, Black);
				/* Clear volume value. */
				ssd1306_Clear_region(80, 0, 113, 19, Black);
				oledClearGesture_slider();
				count_startup = 0;
				demo.startup_slider_state = startup_slider_mode2_1;
			}
		}
		break;

	case startup_slider_mode2_1:
		if (ssd1306_CheckScreenReady(500)) {
			oledClearMode();
			oledDisplayText_slider("MODE 2", 50, 44, Font_6x8, White);
			oledDisplayText_slider("SWIPE AND HOLD", 25, 55, Font_6x8, White);
			demo.startup_slider_state = startup_slider_mode2_2;
		}
		break;

	case startup_slider_mode2_2:
		if (ssd1306_CheckScreenReady(200)) {
			if (count_startup<=6) {
				if (count_startup == 0) {
					/* Draw arrow. */
					SSD1306_DrawFilledRectangle(103, 33, 12, 2, White);
					SSD1306_DrawFilledTriangle(116, 37, 116, 31, 123, 34, White);
				}
				else if (count_startup == 3)
				{
					oledDisplayText_slider("HOLD", 101, 30, Font_6x8, White);
				}
				SSD1306_DrawFilledRectangle(0, Y_MIDDLE-4, (26*count_startup/3), 8, White);
				oledDisplayText_slider(utoa(count_startup*10, dispBuff1, 10), 80, 0, Font_11x18, White);

				count_startup += 1;
			} else{
				/* Clear volume bar area. */
				ssd1306_Clear_region(1, Y_MIDDLE-4, 88, Y_MIDDLE+5, Black);
				/* Clear volume value. */
				ssd1306_Clear_region(80, 0, 113, 19, Black);
				oledClearGesture_slider();
				count_startup = 0;
				demo.startup_slider_state = startup_slider_mode3_1;
			}
		}
		break;

	case startup_slider_mode3_1:
		if (ssd1306_CheckScreenReady(500)) {
			oledClearMode();
			oledDisplayText_slider("MODE 3", 50, 44, Font_6x8, White);
			oledDisplayText_slider("PRECISION", 40, 55, Font_6x8, White);
			demo.startup_slider_state = startup_slider_mode3_2;
		}
		break;

	case startup_slider_mode3_2:
		if (ssd1306_CheckScreenReady(40)) {
			if (count_startup<=40) {
				SSD1306_DrawFilledRectangle(0, Y_MIDDLE-4, (6*count_startup/3), 8, White);
				oledDisplayText_slider(utoa(count_startup*2.5, dispBuff1, 10), 80, 0, Font_11x18, White);

				count_startup += 1;
			} else{
				/* Clear volume bar area. */
				ssd1306_Clear_region(1, Y_MIDDLE-4, 88, Y_MIDDLE+5, Black);
				/* Clear volume value. */
				ssd1306_Clear_region(80, 0, 113, 19, Black);
				oledClearGesture_slider();
				count_startup = 0;
				demo.startup_slider_state = startup_slider_clearAll;
			}
		}
		break;


	case startup_slider_clearAll:
		if (ssd1306_CheckScreenReady(200)) {
			/* Clear all on OLED */
			oledClear_slider();
			demo.startup_slider_state = startup_slider_end;
		}
		break;

	case startup_slider_end:
		if (ssd1306_CheckScreenReady(0)) {
			/* Display UI. */
			oledDisplayText_slider("Volume: ", 0, 0, Font_11x18, White);
			/* Display starting volume value. */
			oledDisplayText_slider("30", 80, 0, Font_11x18, White);
			/* Starting volume bar. */
			SSD1306_DrawFilledRectangle(0, Y_MIDDLE-4, (25*3/3), 8, White);
			//base line of volume bar
			SSD1306_DrawLine(0, Y_MIDDLE-9, 0, Y_MIDDLE+9, White);

			oledDisplayText_slider("MODE 1", 50, 44, Font_6x8, White);
			oledDisplayText_slider("SWIPE", 50, 55, Font_6x8, White);


			demo.startup_slider_state = startup_slider_done;
			/* Begin the Run demo interface. */
			demo.run_slider_state = demo_slider_run_begin;
		}
		break;

	case startup_slider_done:
		break;

	default:
		demo.startup_slider_state = startup_slider_begin;
		break;
	}

}


/**
 * @brief Run demo loop to update and display all segments of the demo
 *
 * @param None.
 *
 *	@note Call this function in run board select loop. (Case: board_8btn)
 *
 * @return None
 */
void run_demo_slider(void)
{
	#ifdef DEBUG_DEMO
	LL_GPIO_ResetOutputPin(DEBUG_PORT, DEBUG_PIN);
	#endif

	/* Return if I2C is busy. */
	if ((_iqs269Ptr->openwindow)||(!_iqs269Ptr->jobdone))
		return;

	switch (demo.run_slider_state) {
	case demo_slider_run_startup:
		/* Run startup routine. */
		run_demoStartupRoutine_slider();
		break;

	case demo_slider_run_begin:
		/* Advance to the next state if new information was retrieved from the _iqs269Ptr-> */
		if (_iqs269Ptr->updated)
		{
			demo.run_slider_state = demo_slider_run_relative_coordinates;
		}
		/* Update screen if the UI changed since the last update.*/
		if (demo.update) {
			demo.update = false;
			ssd1306_CheckScreenReady(0);
		}
		break;

	case demo_slider_run_relative_coordinates:
		run_relative_coordinates();
		demo.run_slider_state = demo_slider_run_gestures;
		break;

	case demo_slider_run_gestures:
		run_gestures_slider();
		demo.run_slider_state = demo_slider_run_clearGesture;
		break;

	case demo_slider_run_clearGesture:
		/* Clear the gesture on the screen if 500ms passed since it was displayed and if the touch flag is not set. */
		if (HAL_CheckTick(timerGesture, 500, true) && gestures.clearGesture && touchflag == false)
		{
			gestures.clearGesture = false;
			oledClearGesture_slider();
			demo.update = true;
			holdflagpos = false;
			holdflagneg = false;
			holdflag = false;
		}
		demo.run_slider_state = demo_slider_run_select_mode;
		break;


	case demo_slider_run_select_mode:

		/* Change next run state based on the active mode. */
		switch (modeIndex) {
		case 0:
			demo.run_slider_state = demo_slider_run_swipe_detect;
			break;
		case 1:
			demo.run_slider_state = demo_slider_run_swipe_hold;
			break;
		case 2:
			demo.run_slider_state = demo_slider_run_relative_swipe;
			break;
		default:
			break;
		}
		break;

	case demo_slider_run_swipe_detect:
		/* Mode 1 */
		run_swipe_detect();
		demo.run_slider_state = demo_slider_run_volume;
		break;

	case demo_slider_run_swipe_hold:
		/* Mode 2 */
		run_swipe_hold();
		demo.run_slider_state = demo_slider_run_volume;
		break;

	case demo_slider_run_relative_swipe:
		/* Mode 3 */
		run_relative_swipe();
		demo.run_slider_state = demo_slider_run_volume;
		break;

	case demo_slider_run_volume:
		/* Draw the volume bar and update the volume value displayed. */
		run_volume();
		demo.run_slider_state = demo_slider_run_done;
		break;

	case demo_slider_run_done:
		/* Set iqs269 flag false after information was used. */
		_iqs269Ptr->updated = false;
		demo.run_slider_state = demo_slider_run_begin;
		break;

	case demo_slider_run_idle:
		// Do nothing
		break;

	default:
		break;
	}
	#ifdef DEBUG_DEMO
	LL_GPIO_SetOutputPin(DEBUG_PORT, DEBUG_PIN);
	#endif
}

/* @brief Check if the Mode button is pressed and change the active mode of the demo.
 *
 * @param None.
 *
 * @retval None.
 */
void run_select_mode(void)
{
	/* Skip the startup routine if it is currently running. */
	if (demo.startup_slider_state < startup_slider_end)
	{
		demo.startup_slider_state = startup_slider_clearAll;
	}
	else
	{
		/* Set start position of volume bar and value. */
		init_volume_startpos();
		//		modeTimer = HAL_GetTick();

		if(modeIndex >= 2)
		{
			/* Start over at Mode 1. */
			modeIndex = 0;
		}
		else
		{
			/* Advance to next mode. */
			modeIndex++;
		}

		/* Update UI Mode text. */
		switch (modeIndex) {
		case 0:
			oledClearMode();
			oledDisplayText_slider("MODE 1", 50, 44, Font_6x8, White);
			oledDisplayText_slider("SWIPE", 50, 55, Font_6x8, White);
			break;
		case 1:
			oledClearMode();
			oledDisplayText_slider("MODE 2", 50, 44, Font_6x8, White);
			oledDisplayText_slider("SWIPE AND HOLD", 25, 55, Font_6x8, White);
			break;
		case 2:
			oledClearMode();
			oledDisplayText_slider("MODE 3", 50, 44, Font_6x8, White);
			oledDisplayText_slider("PRECISION", 40, 55, Font_6x8, White);
			break;
		default:
			break;
		}

		run_volume();
		demo.update = true;
	}
}

/* @brief Update the relative coordinates buffer.
 *
 * @param None.
 *
 * @retval None.
 */
void run_relative_coordinates(void)
{
	uint8_t new_xCoord;

	if(!iqs269_Channel_TouchState(IQS269_CH0))
	{
		/* CH0 of the IQS269 is connected to all 8 buttons on the button board. */
		touch_index = 0;
	}
	else if(iqs269_Channel_TouchState(IQS269_CH0))
	{
		new_xCoord = iqs269_SliderCoordinates(IQS269_SL0);

		//		Smoothing for readability - Moving Average		//
		/* Coordinate limit conditioning. */
		/* X coordinate. */
		if (new_xCoord < X_LCL)
		{
			new_xCoord = X_LCL;
		}
		if (new_xCoord > X_UCL)
		{
			new_xCoord = X_UCL;
		}
		new_xCoord = ((new_xCoord - X_LCL)*X_MAX)/(X_UCL - X_LCL);


		if (!firstTouch_slider)
		{
			/* Initialize filter arrays with the first touch information. */
			coordinates.x_filter[4] = new_xCoord;
			coordinates.x_filter[3] = new_xCoord;
			coordinates.x_filter[2] = new_xCoord;
			coordinates.x_filter[1] = new_xCoord;
			coordinates.x_filter[0] = new_xCoord;

			firstTouch_slider = true;
		}
		else
		{
			/* Filter x coordinates. */
			coordinates.x_filter[4] = coordinates.x_filter[3];
			coordinates.x_filter[3] = coordinates.x_filter[2];
			coordinates.x_filter[2] = coordinates.x_filter[1];
			coordinates.x_filter[1] = coordinates.x_filter[0];
			coordinates.x_filter[0] = new_xCoord;

		}

		new_xCoord = (coordinates.x_filter[0] + coordinates.x_filter[1] + coordinates.x_filter[2] + coordinates.x_filter[3] + coordinates.x_filter[4])/5;
		/////////////////////////////////////////////////////////

		if(touch_index < 10)
		{
//			relative_coord[0] = iqs269_SliderCoordinates(IQS269_SL0);
//			relative_coord[1] = iqs269_SliderCoordinates(IQS269_SL0);
			relative_coord[0] = new_xCoord;
			relative_coord[1] = new_xCoord;
			touch_index++;
		}
		else
		{
			relative_coord[0] = relative_coord[1];
			relative_coord[1] = iqs269_SliderCoordinates(IQS269_SL0);
			if(modeIndex == 2)
			{
				/* Scale the coordinates value (0-255) to a volume value in the range 0-100. */
				volume.absVol = coordinates.xCoord*100/255;
			}
		}
	}
}

/* @brief Run volume function simply calls the function that draws the volume bar.
 *
 * @param None.
 *
 * @retval None.
 */
void run_volume(void)
{
	/* This function draws the volume bar. coordinates.xCoord is the length of the bar and volume.absVol is the volume value displayed. */
	oledVolumeBar(coordinates.xCoord, volume.absVol);
}

/**
 * @brief Update the gestures UI and update the screen with the gesture. Additionally, this function set flags so that a swipe and hold gesture can be identified.
 *
 * @param None
 *
 * @return None
 */
void run_gestures_slider(void)
{
	/* CH0 of the IQS269 is connected to all 8 buttons on the button board. */
	if(iqs269_Channel_TouchState(IQS269_CH0))
	{
		texttimer = HAL_GetTick();
	}
	else
	{
		texttimer = 0;
		writeHOLD = false;
		touchflag = false;
	}

	if (iqs269_GestureEvent())
	{
		switch (iqs269_SliderEvent(IQS269_SL0))
		{
			case FLICK_NEG_0:
				oledClearGesture_slider();
				holdflagneg = true;
				holdflagpos = false;
				holdtimer = HAL_GetTick();
				writeHOLD = true;
				touchflag = true;


				// draw left arrow
				if(modeIndex != 2)
				{
					SSD1306_DrawFilledRectangle(111, 33, 12, 2, White);
					SSD1306_DrawFilledTriangle(111, 37, 111, 31, 104, 34, White);
				}

				break;
			case FLICK_POS_0:
				oledClearGesture_slider();
				holdflagpos = true;
				holdflagneg = false;
				holdtimer = HAL_GetTick();
				writeHOLD = true;
				touchflag = true;

				//draw right arrow
				if(modeIndex != 2)
				{
					SSD1306_DrawFilledRectangle(103, 33, 12, 2, White);
					SSD1306_DrawFilledTriangle(116, 37, 116, 31, 123, 34, White);
				}
				break;
			case HOLD_0:



				break;
			case TAP_0:

				break;
			case NO_GESTURE_0:

				break;
			default:
				break;
		}

		gestures.clearGesture = true;
		timerGesture = HAL_GetTick();
		demo.update = true;

	}

	if(HAL_CheckTick(holdtimer, 250,  true) && iqs269_Channel_TouchState(IQS269_CH0) && modeIndex == 1 && writeHOLD == true )
	{
		oledClearGesture_slider();
		oledDisplayText_slider("HOLD", 101, 30, Font_6x8, White);
		writeHOLD = false;
	}

	if(HAL_CheckTick(holdtimer, 100, true) && touchflag == true && modeIndex == 1)
	{

		holdflag = true;
		//tempGesture = SWOLD_0;


	}
	else
	{
		tempGesture = NO_GESTURE_0;
		holdflag = false;
	}
}

/* @brief Set the absolute volume and the x-coordinate starting values.
 *
 * @param None.
 *
 * @retval None.
 */
void init_volume_startpos(void)
{
	volume.absVol = 30;
	coordinates.xCoord = 77;
}

/* @brief Increase or decrease the volume with swipes. (Mode 1)
 *
 * @param None.
 *
 * @retval None.
 */
void run_swipe_detect(void)
{
	uint8_t temp_vol;
	uint8_t	temp_coord;

	if (iqs269_GestureEvent())
	{
		switch (iqs269_SliderEvent(IQS269_SL0)) {
		case FLICK_NEG_0:
			temp_vol = volume.absVol - 10;

			/* Check for overflow. */
			if(temp_vol > volume.absVol)
			{
				volume.absVol = 0;

			}
			else
			{
				volume.absVol = temp_vol;
			}

			temp_coord = coordinates.xCoord - 26;

			if(temp_coord > coordinates.xCoord)
			{
				coordinates.xCoord = 0;
			}
			else
			{
				coordinates.xCoord = temp_coord;
			}
			break;

		case FLICK_POS_0:
			temp_vol = volume.absVol + 10;

			if(temp_vol < volume.absVol || temp_vol > 100)
			{
				volume.absVol = 100;
			}
			else
			{
				volume.absVol = temp_vol;
			}

			temp_coord = coordinates.xCoord + 26;
			if(temp_coord < coordinates.xCoord)
			{
				coordinates.xCoord = 255;
			}
			else
			{
				coordinates.xCoord = temp_coord;
			}
			break;

		case HOLD_0:
			break;
		case TAP_0:
			break;
		case NO_GESTURE_0:
			break;
		default:
			break;
		}
	}
}


/* @brief Increase or decrease the volume with swipes and keep increasing or decreasing while holding after swipe. (Mode 2)
 *
 * @param None.
 *
 * @retval None.
 */
void run_swipe_hold(void)
{
	uint8_t temp_vol;
	uint8_t	temp_coord;

	if (iqs269_GestureEvent())
	{
		switch (iqs269_SliderEvent(IQS269_SL0)) {
		case FLICK_NEG_0:
			temp_vol = volume.absVol - 10;

			if(temp_vol > volume.absVol)
			{
				volume.absVol = 0;
			}
			else
			{
				volume.absVol = temp_vol;
			}

			temp_coord = coordinates.xCoord - 26;
			if(temp_coord > coordinates.xCoord)
			{
				coordinates.xCoord = 0;
			}
			else
			{
				coordinates.xCoord = temp_coord;
			}
			break;

		case FLICK_POS_0:
			temp_vol = volume.absVol + 10;

			if(temp_vol < volume.absVol || temp_vol > 100)
			{
				volume.absVol = 100;
			}
			else
			{
				volume.absVol = temp_vol;
			}

			temp_coord = coordinates.xCoord + 26;
			if(temp_coord < coordinates.xCoord)
			{
				coordinates.xCoord = 255;
			}
			else
			{
				coordinates.xCoord = temp_coord;
			}
			break;

		case HOLD_0:
			break;
		case TAP_0:
			break;
		case NO_GESTURE_0:
			break;
		default:
			break;
		}
	}

	if(holdflag == true && HAL_CheckTick(volbartimer, 200, true))
	{
		volbartimer = HAL_GetTick();

		if(holdflagpos)
		{
			temp_vol = volume.absVol + 10;

			if(temp_vol < volume.absVol || temp_vol > 100)
			{
				volume.absVol = 100;
			}
			else
			{
				volume.absVol = temp_vol;
			}

			temp_coord = coordinates.xCoord + 26;
			if(temp_coord < coordinates.xCoord)
			{
				coordinates.xCoord = 255;
			}
			else
			{
				coordinates.xCoord = temp_coord;
			}
		}

		if(holdflagneg)
		{
			temp_vol = volume.absVol - 10;

			if(temp_vol > volume.absVol)
			{
				volume.absVol = 0;

			}
			else
			{
				volume.absVol = temp_vol;
			}

			temp_coord = coordinates.xCoord - 26;
			if(temp_coord > coordinates.xCoord)
			{
				coordinates.xCoord = 0;
			}
			else
			{
				coordinates.xCoord = temp_coord;
			}
		}

	}

}

/* @brief Run function for the relative coordinate mode. Calculates the swipe delta and updates the x-coord accordingly. (Mode 3)
 *
 * @param None.
 *
 * @retval None.
 */
void run_relative_swipe(void)
{
	//uint8_t temp_vol;
	uint8_t	temp_coord;
	int16_t swipe_delta;

	if (iqs269_Channel_TouchState(IQS269_CH0))
	{

		swipe_delta = relative_coord[1] - relative_coord[0];


			if(swipe_delta > 0)
			{

				temp_coord = coordinates.xCoord + swipe_delta;

				if(temp_coord < coordinates.xCoord)
				{
					coordinates.xCoord = 255;
				}
				else
				{
					coordinates.xCoord = temp_coord;
				}

			}
			else if(swipe_delta < 0)
			{
				temp_coord = coordinates.xCoord + swipe_delta;

				if(temp_coord > coordinates.xCoord)
				{
					coordinates.xCoord = 0;
				}
				else
				{
					coordinates.xCoord = temp_coord;
				}
			}
	}


}

/**
 * @brief Set the cursor and write text.
 *
 * @param char* : \b text - Specifies the text to be written.
 * @param uint8_t : \b xCoord -  Specifies the x coordinate of the cursor.
 * @param uint8_t : \b yCoord -  Specifies the y coordinate of the cursor.
 * @param FontDef : \b Font -  Specifies the size of the text.
 * @param SSD1306_COLOR : \b color -  Specifies the color of the text.
 *
 * @note Example : oledDisplayText("Hello World!", 15, 20, Font_6x8, White);
 * @note To display signed int oledDisplayText(itoa(counts, dispBuff1, 10), 0, 54, Font_6x8, White);
 * @note To display unsigned int use utoa, and for floats use ftoa.
 *
 * @retval None
 */
void oledDisplayText_slider(char* text, uint8_t xCoord, uint8_t yCoord, FontDef Font, SSD1306_COLOR color)
{
	ssd1306_SetCursor(xCoord, yCoord);
	ssd1306_WriteString(text, Font, color);
}

/**
 * @brief Clear the entire screen to Black.
 *
 * @param None
 *
 * @return None
 */
void oledClear_slider(void)
{
	ssd1306_Fill(Black); // Clear all
}

/* @brief Clears the OLED Gesture display.
 *
 * @param None.
 *
 * @return None.
 */
void oledClearGesture_slider(void)
{
	//SSD1306_DrawFilledRectangle(101, 30, 27, 20, Black);
	ssd1306_Clear_region(101, 30, 128, 50, Black);
}

/* @brief Clears the OLED mode display segment
 *
 * @param None.
 *
 * @return None.
 */
void oledClearMode(void)
{
	//SSD1306_DrawFilledRectangle(0, 55, 107, 7, Black);
	ssd1306_Clear_region(0, 55, 108, 62, Black);
}

/* @brief Clears the OLED PM display.
 *
 * @param None.
 *
 * @retval None.
 */
void oledClearPM_slider(void)
{
	//SSD1306_DrawFilledRectangle(X_MIDDLE - 15, 0, 40, 12, Black);
	ssd1306_Clear_region(X_MIDDLE - 15, 0, X_MIDDLE + 25, 12, Black);
}

/* @brief Draw a horizontal bar representing the volume
 *
 * @param int16_t : \b delta -  Specifies the length of the bar. The x-coordinate is typically sent as a parameter.
 * @param uint8_t : \b vol -  Specifies the value of the volume. This is the volume displayed.
 *
 * @retval None.
 */
void oledVolumeBar(int16_t delta, uint8_t vol)
{
	int16_t difference;
	char dispBuff1[64];
	if (vol != volume.prev_vol) {
		// Display the delta value
		if (((vol < 10) && (volume.prev_vol > 9)) || (volume.prev_vol == 100)) {
			//SSD1306_DrawFilledRectangle(80, 0, 33, 18, Black);
			ssd1306_Clear_region(80, 0, 113, 19, Black);
		}

		oledDisplayText_slider(utoa(vol, dispBuff1, 10), 80, 0, Font_11x18, White);

		if (delta >= 0)
		{
			if ((volume.prev_delta > delta) ) {	//&& ((delta/3) >= 1)
				//only clear the difference
				difference = volume.prev_delta - delta;
//				SSD1306_DrawFilledRectangle((delta/3), Y_MIDDLE-4, (difference/3)+1, 8, Black);
				ssd1306_Clear_region((delta/3), Y_MIDDLE-4, (difference/3)+(delta/3)+2, Y_MIDDLE+5, Black);

			} else // delta greater than prev delta
			{
				//only draw the difference
				difference = delta - volume.prev_delta;

				/* The bar sometimes miss one row of pixels. Check this condition to fix this bug. */
				if (delta > 5) {
					SSD1306_DrawFilledRectangle(volume.prev_delta/3, Y_MIDDLE-4, (difference/3), 8, White);
				} else
				{
					SSD1306_DrawFilledRectangle(volume.prev_delta/3, Y_MIDDLE-4, difference/3, 8, White);
				}
			}
		}
		/* Redraw base line. */
		if (vol == 0) {
			//base line of volume bar
			SSD1306_DrawLine(0, Y_MIDDLE-9, 0, Y_MIDDLE+9, White);
		}

		/* Save previous values. */
		volume.prev_delta = delta;
		volume.prev_vol = vol;
		/* Set flag so screen will update. */
		demo.update = true;
	}

}

/**
 * @brief  		Initialize the pointer to the iqs269 instance
 *
 * @param  	iqs269_s* : \b iqs269 - Pointer to iqs269 instance
 *
 * @return 		None
 */
void iqs269_pointer_init_slider(iqs269_s *iqs269)
{
	_iqs269Ptr = iqs269;
}

